import java.math.BigDecimal;


public class ComboBoxItem {
	private int numGeneration;
	private Chromosome chromosome;

	public ComboBoxItem(Chromosome chr, int gen){
		chromosome = chr;
		numGeneration = gen;
	}
	
	public String toString(){
		BigDecimal bg;
		try{
			 bg = new BigDecimal(chromosome.getFitnessMin());
		}
		catch(java.lang.NumberFormatException e){
			bg = new BigDecimal(1000);
		}
		bg = bg.setScale(4, BigDecimal.ROUND_HALF_UP);
		double a = bg.doubleValue();
		return "Gen#: " + numGeneration +" | FF: " + a;
	}

	/**
	 * @return the numGeneration
	 */
	public int getNumGeneration() {
		return numGeneration;
	}

	/**
	 * @param numGeneration the numGeneration to set
	 */
	public void setNumGeneration(int numGeneration) {
		this.numGeneration = numGeneration;
	}

	/**
	 * @return the chromosome
	 */
	public Chromosome getChromosome() {
		return chromosome;
	}

	/**
	 * @param chromosome the chromosome to set
	 */
	public void setChromosome(Chromosome chromosome) {
		this.chromosome = chromosome;
	}
}