import javax.swing.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.border.TitledBorder;
import java.math.BigDecimal;
import communication.handler.ProtocolHandler;
import communication.handler.internal.InternalHandler;
import communication.transport.ConnectionProvider;

public class GAMP extends JFrame {

	// Inizializzazione simulazione
	public static SimulationData newSimul;

	// VARIABILI PER GRAFICA
	public static int ffType = 1;
	public static boolean stop = false;
	public static boolean pmap = false;
	public static boolean systemout = true;
	public static boolean social = false;
	public static int steptemp=1000;
	public static int acqtemp=100;
	public static String comtemp="COM40";
	public static int ngenitemp=10;
	public static int nindtemp=10;
	public static int pcrosstemp=90;
	public static int pmutatemp=10;
	public static int atemp=8;
	JPanel pnlNorth = new PanelNorth();
	JPanel pnlSouth = new PanelSouth();
	JPanel pnlSpace = new PanelSpace();
	JPanel pnlTool = new PanelTools();
	JPanel pnlCenter = new PanelCenter();
	JLabel label;
	JLabel label0;
	JLabel label1;
	JLabel label2;
	JLabel label3;
	JLabel label4;
	JLabel label5;
	JLabel labelCOM;
	JLabel animLabel;
	Wait winAnimation;
	JLabel status;
	JTextField txtNGoalvalue;
	JTextField txtPMutavalue;
	JTextField txtPCrossvalue;
	JTextField txtPercValue;
	JTextField txtRowsValue;
	JTextField txtColumnsValue;
	JTextField txtNGenivalue;
	JTextField txtNIndvalue;
	JTextField txtCOMvalue;
	JTextField txtStepvalue;
	JTextField txtNGenValue;
	JTextField txtAcquisStep;
	JComboBox typeMapGen;
	JComboBox thisGenMenu;
	JComboBox bestIndivMenu;
	JButton btnAbort;
	JButton btnSpeed;
	JButton btnMapGen;
	JButton btnActivate;
	JButton btnDeactivate;
	JButton btnCancel;
	JButton btnGoal;
	JButton btnObstacle;
	JButton btnOld;
	JButton btnStart;
	JButton btnSave;
	JButton btnProceed;
	JButton btnOptimum;
	JButton btnOk;
	JFileChooser fc;
	JSlider ffSlider;
	JButton openButton, saveButton;
	ImageIcon animImage;
	PanelEnvironment pnlEnvironment;
	// Finestra di errore
	WinError win;
	public JMenuItem menuItem2;
	public JRadioButtonMenuItem radioItem1; // Radio button sul menu dei Parametri
	public JRadioButtonMenuItem radioItem2;
	public JRadioButtonMenuItem radioItem3;
	public JRadioButtonMenuItem radioItem4;
	public JRadioButtonMenuItem radioItem5;
	public JRadioButtonMenuItem radioItem6;
	public JRadioButtonMenuItem radioItem7;
	public JRadioButtonMenuItem radioItem8;
	public JRadioButtonMenuItem radioItem9;
	public JRadioButtonMenuItem radioItem10;
	public JRadioButtonMenuItem radioItem11;
	public JRadioButtonMenuItem radioItem12;
	public JRadioButtonMenuItem radioItem13;
	public JRadioButtonMenuItem radioItem14;
	public JRadioButtonMenuItem radioItem15;
	public JRadioButtonMenuItem radioItem16;
	public JRadioButtonMenuItem radioShowBeyond;
	public static boolean gps;
	public static int test;
	public static int selectionType = 1;
	public static int crossoverType = 1;
	public static int mutationType = 1;
	public static boolean collide = false;
	public static boolean anim = false;
	public static boolean init = true;

	public static int muta=1;
	public static int cross=1;
	public static int sel=1;
	public static String mutan;
	public static String crossn;
	public static String seln;
	public static String ffn;
	public static String matrixarg;

	public static boolean savedStart; // Variabile per controllare la presenza dello start
	public static boolean savedGoal; // Variabile per controllare la presenza del goal
	public static boolean savedMap; // Variabile per controllare se e' stata
	// salvata la mappa e quindi visualizzare il simulatore
	public static boolean abort = false;
	public static int width = 800; // Larghezza finestra
	public static int height = 600; // Lunghezza finestra
	public static int panx = 10; // Larghezza finestra
	public static int pany = 10; // Lunghezza finestra

	public class InitStatus { // Enum degli stati intermedi della procedura di creazione dell'ambiente
		public static final int DEF_BORDERS = 0; // fase di definizione del bord
		public static final int DEF_BEGIN = 1; // fase di definizione della posizione iniziale
		public static final int DEF_GOAL = 2; // fase di definizione della posizione del goal
		public static final int DEF_OBSTACLES = 3; // fase di definizione della posizione degli ostacoli
		public static final int DONE = 4; // creazione ambiente completata
	}

	public static int initStatus = InitStatus.DEF_BORDERS;

	// VARIABILI PER CONNESSIONE ROBOT e GENERAZIONE GENI
	public static String portName = "COM40";
	public static String genes = "";
	public static int ngenimax;
	public static int perimeter;
	private ProtocolHandler protocol;
	private InternalHandler internal;
	private MovControl mov;
	
	public static Thread simulator;
	Thread robot;
	public boolean active;
	public static GAMP gui;
	public boolean connect = false;
	
	// PARAMETRI FISICI
	// public final int ULTRA_MAX=27; //Distanza muro ultrasuoni in centimetri
	// public final int ULTRA_REFRESH=200; //Refresh valori ultrasuoni in millisecondi

	public static final String TITLE = "GAMP: Genetic Algorithm for Motion Planning";
	public static final String ERROR = "Errore di ";
	public static final String[] TXT = { "Loading Genes, Enviroment, GUI and Robot...", // 0
			"View", // 1
			"Info box", // 2
			"Map Editor", // 3
			"# Agents:", // 4
			"# Genes:", // 5
			"Click-and-Drag to define the perimeter or generate a map using the Map Generator", // 6
			"Draw start position of robot", // 7
			"Draw goal position of robot", // 8
			"Draw obstacles.", // 9
			"Simulator", // 10
			"Too much obstacles", // 11
			"Map dimension is not a valid", // 12
			"The number of agents must be even.", // 13
			"The number of agents must be greater than zero.", // 14
			"The number of genes is too small to achieve the goal.", // 15
			"Error when reading map.", // 16
			"Failed to connect to robot at port ", // 17
			"Connection failed", // 18
			"Empty map", // 19
			"Acquisition step", // 20
			"Latest Generation", // 21
			"Best agents", // 22
			"Activate", // 23
			"Connect and start the robot.", // 24
			"Disactivate", // 25
			"% Crossover:", // 26
			"% Mutation:", // 27
			"Probability value of crossover", // 28
			"Probability value of mutation", // 29
			"Optimum solution proximity", // 30
			"% Optimum", // 31
			"Generation:", // 32
			"Old Map", // 33
			"Completed!", // 34
			"Evolution...", // 35
			"Aborted.", // 36
			"Hide output", // 37
			"Faster", // 38
			"Show output", // 39
			"Slower", // 40
			"Map generated", // 41
			"Map reloaded", // 42
			"Ready", // 43
	};

	// MAIN
	public static void main(String[] args) {
		//Inizializzo
	
	
		
		// Elimino il file log
		(new File("log.dat")).delete();
	
		if(args.length==7){
			
			seln=args[2];
			if(args[2].equals("rank"))
				sel=3;
			else if(args[2].equals("tournament"))
				sel=1;
			else if(args[2].equals("roulette"))
				sel=2;
			//Crossover
			crossn=args[3];
			if(args[3].equals("onepoint"))
				cross=1;
			else if(args[3].equals("twopoint"))
				cross=2;
			else if(args[3].equals("oneuniform"))
				cross=3;
			if(args[3].equals("twouniform"))
				cross=4;
			//Mutazioni
			mutan=args[4];
			if(args[4].equals("simple"))
				muta=1;
			else if(args[4].equals("uniform"))
				muta=3;
			//FitnessFuction
			ffn=args[5];
			if(args[5].equals("rigid")){
				
				Move.a = 0.2;
				Move.b = 0.8;
			}else if(args[5].equals("elastic")){
				Move.a = 0.5;
				Move.b = 0.5;
			}
			int ngeniarg=Integer.parseInt(args[0]);
			int nindarg=Integer.parseInt(args[1]);
			String matrixarg=args[6];
			
			for(test=0;test<6;test++){
				systemout=false;
				newSimul = new SimulationData();
				try {
					newSimul.loadMatrix(matrixarg+".map");
				} catch (IOException e) {
					e.printStackTrace();
				}
				newSimul.setNGenes(ngeniarg);
				newSimul.setNIndiv(nindarg);
				//Selezione
			
				// inizializza dati silulazione
				if (newSimul.getNGenerations() == 0)
					newSimul.initSimulation();
				if (newSimul.getSolution() == null && !abort)
					newSimul.calcNextGenerations(10000, sel, cross, 0.9, muta, 0.1);
				if (newSimul.getSolution() != null) {
					
					int optimum = 1;
					String a = OptimumList.calcolaOttimo(matrixarg+".map");
					if (a == null) return;
						optimum = a.length();
					System.out.println(test+"\t"+optimum+"\t" + Move.ngenesbeforegoal+"\t"+newSimul.currGeneration);
					
				}
				else{	System.out.println("Soluzione non trovata");}
			}
		}
		else if(args.length==2) 
			if(!args[0].equals("-h")){
			System.out.println("**************************************\nStarting simulation on "+args[0]);
			matrixarg=args[0];
			systemout=false;
			int countdown=0;
			gps=true;
			newSimul = new SimulationData();
			try {
				newSimul.loadMatrix(matrixarg+".map");
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			
			int optim = 1;
			String len = OptimumList.calcolaOttimo(matrixarg+".map");
			if (len == null) return;			
			optim = len.length();
			
	
			int ngeniMax = ((newSimul.envMat.length - 1) * (newSimul.envMat[0].length - 1)) / 2;
			int ngeniMin = (ngeniMax + optim) / 2;
			try {
				// Create file
				FileWriter fstream = new FileWriter("logall.dat", true);
				BufferedWriter out = new BufferedWriter(fstream);
				out.write("Log\n"+args[0]+"\n960 iterazioni\nsel\tcross\tmuta\tff\t#geni\t#ind\t#test\topt\t#genesBG\tcurrgen\n");
				// Close the output stream
				out.close();
			} catch (Exception e) {// Catch exception if any
				System.err.println("Error: " + e.getMessage());
			}
			
			for(sel=1; sel<=3;sel++){
				if(sel==1) seln="tournament";
				else if(sel==2) seln="roulette";
				else if(sel==3) seln="rank";
				
				for(cross=1; cross<=4;cross++){
					if(cross==1) crossn="onepoint";
					else if(cross==2) crossn="twopoint";
					else if(cross==3) crossn="oneuniform";
					else if(cross==4) crossn="twouniform";
					
					for(muta=1;muta<=3; muta+=2){
						if(muta==1) mutan="simple";
						else if(muta==3) mutan="uniform";
						
						for(int ff=0; ff<=1; ff++){
							if(ff==0){		
								ffn="rigid";
								Move.a = 0.2;
								Move.b = 0.8;
							}else{
								ffn="elastic";
								Move.a = 0.8;
								Move.b = 0.2;
							}
							//ffn= ff+"";
							
							for(int geni=0;geni<=1;geni++){
								int ngeniarg;
								if(geni==0) ngeniarg=ngeniMin;
								else ngeniarg=ngeniMax;
								
								for(int ind=10; ind <=50;ind+=40){
									for(test=0;test<5;test++){
										systemout=false;
										countdown++;
										System.out.print("\r"+(int)(((double)countdown/(double)960)*100)+"%");
										newSimul = new SimulationData();
										try {
											newSimul.loadMatrix(matrixarg+".map");
										} catch (IOException e) {
											e.printStackTrace();
										}
										newSimul.setNGenes(ngeniarg);
										newSimul.setNIndiv(ind);
										//Selezione
									
										// inizializza dati silulazione
										if (newSimul.getNGenerations() == 0)
											newSimul.initSimulation();
										if (newSimul.getSolution() == null && !abort)
											newSimul.calcNextGenerations(10000, sel, cross, 0.9, muta, 0.1);
										int optimum = 1;
										String a = OptimumList.calcolaOttimo(matrixarg+".map");
										if (a == null)	return;
										optimum = a.length();
										if (newSimul.getSolution() != null) {
											try {
												// Create file
												FileWriter fstream = new FileWriter("logall.dat", true);
												BufferedWriter out = new BufferedWriter(fstream);
												out.write(seln + "\t" + crossn + "\t" + mutan + "\t" + ffn + 
														"\t" + ngeniarg + "\t" + ind + "\t" + test + "\t" 
														+ optimum + "\t" + Move.ngenesbeforegoal + "\t" + 
														newSimul.currGeneration+"\n");
												// Close the output stream
												out.close();
											} catch (Exception e) {// Catch exception if any
												System.err.println("Error: " + e.getMessage());
											}
											
											newSimul.delete();
											newSimul = null;
											System.gc();
										}
										else{	
											
											try {
												// Create file
												FileWriter fstream = new FileWriter("logall.dat", true);
												BufferedWriter out = new BufferedWriter(fstream);
												out.write(
														seln + "\t" + crossn + "\t" + mutan + "\t" + ffn + 
														"\t" + ngeniarg + "\t" + ind + "\t" + test + "\t" 
														+ optimum + "\t" + -1 + "\t" + 
														newSimul.currGeneration+"\n");
												// Close the output stream
												out.close();
											} catch (Exception e) {// Catch exception if any
												System.err.println("Error: " + e.getMessage());
											}
											}
									}
								}
									
							}
							
							
						}
						
					}
					
				}
			}
			try {
			      String line;
			      Process p = Runtime.getRuntime().exec
			        (args[1]+"\\bin\\matlab -r plotall");
			      BufferedReader input =
			        new BufferedReader
			          (new InputStreamReader(p.getInputStream()));
			      while ((line = input.readLine()) != null) {
			        System.out.println(line);
			      }
			      input.close();
			    }
			    catch (Exception err) {
			      err.printStackTrace();
			    }
			
		}else{
			
				System.out.println("<numero geni>\n<numero individui>\t[10,50]\n<selection type>\t[rank,tournament,roulette]\n<crossover type>\t[onepoint,twopoint,oneuniform,twouniform]\n<mutation type>\t\t[simple,uniform]\n<fitness function>\t[rigid,elastic]\n<nome file mappa>\n");
			
				

			
		}
		else{
			newSimul = new SimulationData();
			// carica il look and feel del sistema operativo corrente
			try {
				UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			} catch (Exception e) {
				e.printStackTrace();
			}
		
			
			// Porta bluetooth COM40
			// creo la GUI
			gui = new GAMP();
			gui.setVisible(true);
		}
	}// main

	/****************************************************************************************************************/
	/************************************************ G*U*I **********************************************************/
	/****************************************************************************************************************/
	// SPLASH SCREEN
	static void renderSplashFrame(Graphics2D g, int frame, String txt) {
		g.setComposite(AlphaComposite.Clear);
		g.fillRect(175, 415, 380, 40);
		g.setPaintMode();
		g.setColor(Color.BLUE);
		g.drawString(txt, 180, 405);
		g.fillRect(175, 415, (frame * 10) % 380, 20);
		g.setComposite(AlphaComposite.Clear);
	}

	/**
	 * Aggiorna le combobox di visualizzazione dei percorsi dell'ultima
	 * generazione o dei migliori ottenuti nelle varie generazioni.
	 */
	public void updateComboBoxes() {
		int acquisStep;
		try {
			acquisStep = Integer.parseInt(txtAcquisStep.getText());
		} catch (NumberFormatException err) {
			return;
		}

		thisGenMenu.removeAllItems();
		for (int i = 0; i < newSimul.runningGeneration.length; i++) {
			ComboBoxItem newItem = new ComboBoxItem(newSimul.runningGeneration[i], (newSimul.currGeneration - 1));
			thisGenMenu.addItem(newItem);
		}
		int startVal = 0;
		int i = 0;

		bestIndivMenu.removeAllItems();

		for (i = startVal; i < newSimul.allGenerations.size(); i += acquisStep) {
			Chromosome[] runningGeneration = ((Chromosome[]) (newSimul.allGenerations.get(i)));
			int j = 0;
			double minFF = 1000000;
			int minIndex = 0;
			for (j = 0; j < runningGeneration.length; j++) {
				if(runningGeneration[j].getFitnessMin() == 10000){
					minIndex=j;
					break;
				}
				if (runningGeneration[j].getFitnessMin() <= minFF) {
					minFF = runningGeneration[j].getFitnessMin();
					minIndex = j;
				}
				
			}
			ComboBoxItem newItem = new ComboBoxItem(runningGeneration[minIndex], i);
			bestIndivMenu.addItem(newItem);
		}

		//Se ho soluzione e non viene campionata l'ultima aggiungo l'ultima generazione
		if (newSimul.allGenerations.size() - 1 % acquisStep != 0) {
			double minFF = 1000000;
			int minIndex = 0;
			for (int j = 0; j < newSimul.runningGeneration.length; j++) {
				if(newSimul.runningGeneration[j].getFitnessMin() == 10000){
					minIndex=j;
					break;
				}
				if (newSimul.runningGeneration[j].getFitnessMin() <= minFF) {
					minFF = newSimul.runningGeneration[j].getFitnessMin();
					minIndex = j;
				}
				
			}
			ComboBoxItem newItem = new ComboBoxItem(newSimul.runningGeneration[minIndex], newSimul.currGeneration - 1);
			bestIndivMenu.addItem(newItem);
		}
		bestIndivMenu.setSelectedIndex(bestIndivMenu.getItemCount()-1);
	}

	// MAIN FRAME
	/**
	 * Costruttore della finestra principale del programma
	 */
	public GAMP() {
		// Titolo
		super(TITLE);
		
		// Listener sul pulsante di chiusura
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				active = false;
				// Se e' connesso al robot lo disconnetto prima di chiudere
				if (connect)
					disconnetti();
				System.exit(0);
			}
		});
		setLayout(new BorderLayout());
		// SplashScreen all'avvio se JAR Manifest-Version: 1.0
		// Main-Class: SplashTest
		// SplashScreen-Image: images/Logo.jpg
		// se Command
		// java -splash:images/Logo.png GAMP COM40

		if (init) {
			final SplashScreen splash = SplashScreen.getSplashScreen();
			if (splash == null) {
				if (systemout)
					System.out.println(ERROR + "SplashScreen");
			} else {
				Graphics2D g = (Graphics2D) splash.createGraphics();
				for (int i = 0; i < 40; i++) {
					splash.update();
					renderSplashFrame(g, i, TXT[0]);
					try {
						Thread.sleep(80);
					} catch (InterruptedException e) {
					}
				}
				splash.close();
				setVisible(true);
				toFront();
				init = false;
			}
		}
		// Grandezza finestra
		setBounds(panx, pany, width, height);
		// Disegno layout
		setLayout(new BorderLayout(10, 10));
		add(pnlNorth, BorderLayout.NORTH);
		add(pnlSpace, BorderLayout.WEST);
		// se simulatore aggiungi il pannelloSud
		add(pnlSouth, BorderLayout.SOUTH);
		add(pnlCenter, BorderLayout.CENTER);
		active = false;
		setJMenuBar(createMenuBar());
	}// GAMP

	/** DISPOSIZIONE PANNELLI MAPPA -INPUT **/
	/** ___________________________________ **/
	/** |___________nord(NORD)______________| **/
	/** | |general(CENTER) | | **/
	/** |_|_____________|___________________| **/
	/** | _________centro(CENTER)___________ | **/
	/** | | tool | env | out | | **/
	/** | | (WEST) | (CENTER) | (EAST) | | **/
	/** | |_________|_____________|________| | **/
	/** |___________sud(SOUTH)____________| | **/
	/** | info(WEST) | | robot(EAST) | | **/
	/** |______________|__|_______________| | **/
	/** |________status(SOUTH)_____________|_| **/

	/** DISPOSIZIONE PANNELLI SIMULATORE **/
	/** ___________________________________ **/
	/** |___________nord(NORD)______________| **/
	/** | |general(CENTER) | step (EAST) | **/
	/** |_|_____________|___________________| **/
	/** | _______ centro(CENTER)____________ | **/
	/** | | | OUTPUT | | **/
	/** | | env(CENTER) | (east) | | **/
	/** | |______________________|________| | **/
	/** |___________sud(SOUTH)____________| | **/
	/** | info(WEST) | | robot(EAST) | | **/
	/** |______________|__|_______________| | **/
	/** |________status(SOUTH)_____________|_| **/

	// Pannello GENERAL [Informazioni generali]
	class PanelGeneral extends JPanel {
		public PanelGeneral() {
			if (savedMap) {
				setLayout(new GridLayout(3, 4, 10, 10));
				// Info su generazione, numero individui ecc..
				setBorder(new TitledBorder(TXT[2]));
				txtNGenValue = new JTextField();
				txtNGenValue.setEditable(false);
				txtNGenValue.setText("" + newSimul.currGeneration);
				label5 = new JLabel(TXT[32]);
				add(label5);
				add(txtNGenValue);
			} else {
				setLayout(new GridLayout(2, 2, 10, 10));
				setBorder(new TitledBorder(TXT[3]));
			}
			label2 = new JLabel(TXT[4]);
			txtNIndvalue = new JTextField("10");
			txtNGoalvalue = new JTextField();
			txtNGoalvalue.setEnabled(false);
			txtNGoalvalue.setToolTipText(TXT[30]);
			label3 = new JLabel(TXT[5]);
			txtNGenivalue = new JTextField();
			txtPCrossvalue = new JTextField(""+pcrosstemp);
			txtPCrossvalue.setToolTipText(TXT[28]);
			txtPMutavalue = new JTextField(""+pmutatemp);
			txtPMutavalue.setToolTipText(TXT[29]);
			if (savedMap) {
				txtNIndvalue.setEditable(false);
				txtNIndvalue.setText("" + newSimul.getNIndiv());
				txtNGenivalue.setEditable(false);
				txtNGenivalue.setText("" + newSimul.getNGenes());
			}
			txtNIndvalue.addFocusListener(new FocusAdapter() {
				public void focusLost(java.awt.event.FocusEvent arg0) {
					if (savedGoal == true && !abort) {
						int value = 0;
						try {
							value = Integer.parseInt(((JTextField) arg0.getSource()).getText());
						} catch (NumberFormatException e) {
							value = 0;
						}
						if (value % 2 != 0) {
							// apro la finestra di errore
							win = new WinError(TXT[13]);
							win.setVisible(true);
							((JTextField) arg0.getSource()).setText(value + 1 + "");
						}
						if (value <= 0) {
							// apro la finestra di errore
							win = new WinError(TXT[14]);
							win.setVisible(true);
							((JTextField) arg0.getSource()).setText(2 + "");
						}
					}
				}
			});
			txtNGenivalue.addFocusListener(new FocusAdapter() {
				public void focusLost(java.awt.event.FocusEvent arg0) {
					if (savedGoal && savedStart) {
						int value = Integer.parseInt(((JTextField) arg0.getSource()).getText());
						int ngenimin = newSimul.getDistance(newSimul.getRobotStartPos(), newSimul.getRobotEndPos());
						if (value < ngenimin) {
							// apro la finestra di errore
							win = new WinError(TXT[15]);
							win.setVisible(true);
							((JTextField) arg0.getSource()).setText(ngenimin + "");
						}
					}
				}
			});

			if (savedMap) {
				add(new JLabel(TXT[31]));
				add(txtNGoalvalue);
				add(label2);
				add(txtNIndvalue);
				add(new JLabel(TXT[26]));
				add(txtPCrossvalue);
				add(label3);
				add(txtNGenivalue);
				add(new JLabel(TXT[27]));
				add(txtPMutavalue);
			} else {
				txtNIndvalue.setSize(300, txtNIndvalue.getHeight());
				txtNGenivalue.setSize(300, txtNGenivalue.getHeight());
				add(label2);
				add(txtNIndvalue);
				add(label3);
				add(txtNGenivalue);
			}
		}
	} // pannelloGeneral

	// Pannello STATUS [barra di stato con i rollover]
	class PanelStatus extends JPanel {
		public PanelStatus() {
			setLayout(new BorderLayout());
			setBorder(BorderFactory.createEtchedBorder());
			status = new JLabel(" ");
			add(new JLabel("Status: "), BorderLayout.WEST);
			add(status, BorderLayout.CENTER);
		}
	}

	// Pannello SUD [Contiene il visualizzatore dei GENI e i pulsanti di avvio del robot]
	class PanelSouth extends JPanel {
		public PanelSouth() {
			setLayout(new BorderLayout(10, 10));
			if (savedMap) {
				JPanel pnlRobot = new PanelRobot();
				JPanel pnlAgents = new PanelAgents();
				add(pnlAgents, BorderLayout.CENTER);
				add(pnlRobot, BorderLayout.EAST);
			}
			JPanel pnlStatus = new PanelStatus();
			add(pnlStatus, BorderLayout.SOUTH);
		}
	} // pannelloSud

	// Pannello AGENTS [Contiene il visualizzatore dei GENI]
	class PanelAgents extends JPanel {
		/**
		 * Aggiorna il contenuto di una delle 2 combobox dell'ultima generazione o dei migliori individui 
		 * @param e handler al componente JComboBox che deve essere aggiornato
		 */
		public void comboChanged(ActionEvent e) {
			try {
				ComboBoxItem cbi = (ComboBoxItem) ((JComboBox) e.getSource()).getSelectedItem();
				String path = cbi.getChromosome().getChromosome();
				pnlEnvironment.currPath = path;
				pnlEnvironment.drawMatrix(pnlEnvironment.getGraphics(), newSimul.envMat);
				pnlEnvironment.drawPath(pnlEnvironment.getGraphics(), path, pnlEnvironment.showBeyond);
				status.setText("Now viewing agent " + path + " | #Gen: " + cbi.getNumGeneration() + " | FF: " + cbi.getChromosome().getFitness());
			} catch (NullPointerException err) {
				//err.printStackTrace();
			}
		}

		public PanelAgents() {
			setBorder(new TitledBorder("Agents"));
			setLayout(new GridLayout(3, 2, 10, 10));
			thisGenMenu = new JComboBox();
			thisGenMenu.setEditable(false);
			thisGenMenu.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					comboChanged(e);
				}
			});
			bestIndivMenu = new JComboBox();
			bestIndivMenu.setEditable(true);
			bestIndivMenu.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					comboChanged(e);
				}
			});
			txtAcquisStep = new JTextField();
			txtAcquisStep.setText(""+acqtemp);
			txtAcquisStep.addKeyListener(new KeyAdapter() {
				public void keyReleased(KeyEvent e) {
					if (newSimul.currGeneration == 0)
						return;
					try {
						if (Integer.parseInt(txtAcquisStep.getText()) == 0)
							return;
					} catch (NumberFormatException err) {
						err.printStackTrace();
					}
					updateComboBoxes();
				}
			});
			add(new JLabel(TXT[21]));
			add(thisGenMenu);
			add(new JLabel(TXT[22]));
			add(bestIndivMenu);
			add(new JLabel(TXT[20]));
			add(txtAcquisStep);
		}
	}// pannelloInfo

	// Pannello STEP[Contiene i pulsanti per lo step delle generazioni]
	class PanelStep extends JPanel {
		public PanelStep() {
			ButtonHandler buttonHandler = new ButtonHandler();
			if (savedMap) {
				setBorder(new TitledBorder("Simulation"));
				setLayout(new BorderLayout(10, 10));
				label4 = new JLabel("Step:");
				txtStepvalue = new JTextField(4);
				txtStepvalue.setEditable(true);
				btnProceed = new JButton(createImageIcon("images/simul.png"));
				btnProceed.addActionListener(buttonHandler);
				btnProceed.setToolTipText("Proceed in simulation for steps.");

				JSlider ffSlider = new JSlider(0, 10, 5);
				ffSlider.setMajorTickSpacing(1);
				ffSlider.setMinorTickSpacing(1);
				ffSlider.setPaintTicks(true);
				ffSlider.setSnapToTicks(true);
				ffSlider.addChangeListener(new Updater());
				ffSlider.setValue(atemp);
				ffSlider.setToolTipText("Fitness Function");

				add(label4, BorderLayout.WEST);
				add(txtStepvalue, BorderLayout.CENTER);
				add(btnProceed, BorderLayout.EAST);

				JPanel ffPanel = new JPanel();
				ffPanel.setLayout(new BorderLayout());
				ffPanel.add(new JLabel("Elastica"), BorderLayout.WEST);
				ffPanel.add(ffSlider, BorderLayout.CENTER);
				ffPanel.add(new JLabel("Rigida"), BorderLayout.EAST);

				add(ffPanel, BorderLayout.SOUTH);
				txtStepvalue.setText(""+steptemp);

			} else {
				setBorder(new TitledBorder("Map Generator"));
				setLayout(new GridLayout(2, 4, 10, 10));
				txtRowsValue = new JTextField(3);
				txtColumnsValue = new JTextField(3);
				txtPercValue = new JTextField(3);
				txtPercValue.setText("20");
				txtRowsValue.setText("10");
				txtColumnsValue.setText("10");
				txtPercValue.setEnabled(false);
				btnMapGen = new JButton("Generate");
				String[] typeMap = { "Perimeter", "Spiral", "Zig Zag", "Random" };
				typeMapGen = new JComboBox(typeMap);
				typeMapGen.setSelectedIndex(0);
				typeMapGen.setEditable(false);
				typeMapGen.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						JComboBox cb = (JComboBox) e.getSource();
						String typeName = (String) cb.getSelectedItem();
						if (typeName == "Random")
							txtPercValue.setEnabled(true);
						else
							txtPercValue.setEnabled(false);
					}
				});
				btnMapGen.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						
						if (!typeMapGen.getSelectedItem().equals("Type")) {
							String typeMap = "";
							int perc;
							if (typeMapGen.getSelectedItem().equals("Perimeter")){
								typeMap = "P";
							pmap=true;
							}
							if (typeMapGen.getSelectedItem().equals("Spiral"))
								typeMap = "C";
							if (typeMapGen.getSelectedItem().equals("Zig Zag"))
								typeMap = "S";
							if (typeMapGen.getSelectedItem().equals("Random")) {
								typeMap = "R";
								perc = Integer.parseInt(txtPercValue.getText());
								if (perc > 98) {
									txtPercValue.setText("98");
									perc = 98;
								}
							} else
								perc = 0;
							if (!txtRowsValue.getText().equals("") && !txtColumnsValue.getText().equals("")) {
								int rows = Integer.parseInt(txtRowsValue.getText());
								int cols = Integer.parseInt(txtColumnsValue.getText());
								if (rows > 1 && cols > 1) {
									generateMap(rows + 2, cols + 2, perc, typeMap);
									updateCompOnMatrixLoad("mappa.txt");
									status.setText(TXT[41] + ": " + TXT[43]);
								} else {
									win = new WinError(TXT[12]);
									win.setVisible(true);
								}
							} else {
								win = new WinError(TXT[12]);
								win.setVisible(true);
							}
						}
					}
				});
				add(new JLabel("Rows:"));
				add(txtRowsValue);
				add(new JLabel("Obstacles %"));
				add(txtPercValue);
				add(new JLabel("Columns:"));
				add(txtColumnsValue);
				add(typeMapGen);
				add(btnMapGen);
			}
		}

		// Update Slidebar
		public class Updater implements ChangeListener {
			public void stateChanged(ChangeEvent e) {
				JSlider source = (JSlider) e.getSource();
				if (!source.getValueIsAdjusting()) {
					double value = (double) source.getValue();
					double a = value;
					double b = Math.abs(10 - a);
					atemp=(int)a;
					BigDecimal bg = new BigDecimal(a / 10);
					bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
					a = bg.doubleValue();
					bg = new BigDecimal(b / 10);
					bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
					b = bg.doubleValue();
					Move.a = a;
					Move.b = b;
					if (systemout)
						System.out.println("FF parameters: " + a + "; " + b);
				}
			}
		}

		// Azioni del bottone PROCEDI
		public class ButtonHandler implements ActionListener {
			public void actionPerformed(ActionEvent e) {
				// Clicco su Procedi...
				if (e.getSource() == btnProceed) {
					
					abort = false;
					stop = false;
					status.setText(TXT[35]);
					status.updateUI();
					winAnimation = new Wait();
					winAnimation.setVisible(true);
					simulator = new Thread(new Simulator());
					simulator.start();
					gui.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
				}
			}

		} // class ButtonHandler
	} // pannelloStep

	// Pannello TOOLS [Toolbar creazione mappa]
	class PanelTools extends JPanel {
		public PanelTools() {
			ButtonHandler buttonHandler = new ButtonHandler();
			setLayout(new GridLayout(6, 3, 10, 10));
			setBorder(new TitledBorder("Toolbar"));
			btnStart = new JButton(createImageIcon("images/start.png"));
			btnStart.setToolTipText(TXT[7]);
			btnGoal = new JButton(createImageIcon("images/goal.png"));
			btnGoal.setToolTipText(TXT[8]);
			btnObstacle = new JButton(createImageIcon("images/obstacle.png"));
			btnObstacle.setToolTipText(TXT[9]);
			btnSave = new JButton(createImageIcon("images/simul.png"));
			btnSave.setToolTipText(TXT[10]);
			btnCancel = new JButton(createImageIcon("images/cancel.png"));
			btnCancel.setToolTipText(TXT[19]);
			btnOld = new JButton(createImageIcon("images/old.png"));
			btnOld.setToolTipText(TXT[33]);
			btnStart.addActionListener(buttonHandler);
			btnGoal.addActionListener(buttonHandler);
			btnObstacle.addActionListener(buttonHandler);
			btnSave.addActionListener(buttonHandler);
			btnCancel.addActionListener(buttonHandler);
			btnOld.addActionListener(buttonHandler);
			add(btnStart);
			add(btnGoal);
			add(btnObstacle);
			add(btnSave);
			add(btnCancel);
			add(btnOld);
			btnStart.setEnabled(false);
			btnGoal.setEnabled(false);
			btnObstacle.setEnabled(false);
			btnSave.setEnabled(false);
			btnCancel.setEnabled(false);
			status.setText("");
			if (abort) {
				btnOld.setEnabled(true);
				status.setText("Aborted.");
				// Elimino il file log
				(new File("log.dat")).delete();
			} else
				btnOld.setEnabled(false);
		}

		/**
		 * Aggiorna lo stato di abilitazione e disabilitazione dei pulsanti del PanelTools
		 */
		public void updateToolButtons() {
			// controllo abilitazione pulsanti
			if (savedGoal && savedStart)
				btnSave.setEnabled(true);
		}

		// Azioni dei bottoni della TOOLBAR
		public class ButtonHandler implements ActionListener {
			// Eventi su pulsanti
			public void actionPerformed(ActionEvent e) {
				status.setText("");
				if (e.getSource() == btnOld) {
					status.setText(TXT[41]);
					updateCompOnMatrixLoad("matrice.txt");
					txtNGenivalue.setText(""+ngenitemp);
					txtNIndvalue.setText(""+nindtemp);
				} else if (e.getSource() == btnStart) {
					status.setText(TXT[7]);
					if (newSimul.getRobotStartPos() != null)
						newSimul.setMatrixValue(newSimul.getRobotStartPos(), SimulationData.matValues.EMPTY);
					initStatus = InitStatus.DEF_BEGIN;
				} else if (e.getSource() == btnGoal) {
					status.setText(TXT[8]);
					if (newSimul.getRobotEndPos() != null)
						newSimul.setMatrixValue(newSimul.getRobotEndPos(), SimulationData.matValues.EMPTY);
					initStatus = InitStatus.DEF_GOAL;
				} else if (e.getSource() == btnObstacle && initStatus != InitStatus.DEF_OBSTACLES) {
					status.setText(TXT[9]);
					initStatus = InitStatus.DEF_OBSTACLES;
				} else if (e.getSource() == btnSave && initStatus != InitStatus.DONE) {
					savedMap = true;
					newSimul.saveMatrix("matrice.txt");
					// Salvo i valori di numero geni e numero individui
					newSimul.setNGenes(Integer.parseInt(txtNGenivalue.getText()));
					newSimul.setNIndiv(Integer.parseInt(txtNIndvalue.getText()));
					status.setText(TXT[10]);
					initStatus = InitStatus.DONE;
					ngenitemp=Integer.parseInt(txtNGenivalue.getText());
					nindtemp=Integer.parseInt(txtNIndvalue.getText());
					// Ridisegno la finestra per passare al simulatore.
					width=gui.getWidth();
					height=gui.getHeight();
					panx=gui.getX();
					pany=gui.getY();
					gui.setVisible(false);
					gui = new GAMP();
					gui.setVisible(true);

				} else if (e.getSource() == btnCancel) {
					// Svuota env
					btnStart.setEnabled(false);
					btnGoal.setEnabled(false);
					txtNGenivalue.setEditable(false);
					txtNIndvalue.setEditable(false);
					btnObstacle.setEnabled(false);
					btnSave.setEnabled(false);
					savedStart = false;
					savedGoal = false;

					newSimul = new SimulationData();
					newSimul.envMat = null;
					width=gui.getWidth();
					height=gui.getHeight();
					panx=gui.getX();
					pany=gui.getY();
					gui.setVisible(false);
					gui = new GAMP();
					gui.setVisible(true);
				}
				updateToolButtons();
			}
		} // class ButtonHandler
	}// pannelloTool

	// Pannello ROBOT [Contiene i pulsanti di avvio del robot]
	class PanelRobot extends JPanel {
		public PanelRobot() {
			ButtonHandler buttonHandler = new ButtonHandler();
			setLayout(new FlowLayout());
			setBorder(new TitledBorder("Robot"));
			labelCOM = new JLabel("Port:");
			txtCOMvalue = new JTextField(6);
			txtCOMvalue.setEditable(true);
			btnActivate = new JButton(TXT[23]);
			btnActivate.setToolTipText(TXT[24]);
			/*
			 * btnActivate.addActionListener(new ActionListener() { public void
			 * actionPerformed(ActionEvent e) { portName=txtCOMvalue.getText();
			 * if (!connetti(txtCOMvalue.getText())) { if(systemout)
			 * if(systemout)
			 * System.out.println("Robot non connesso alla porta"+txtCOMvalue
			 * .getText());} else{ //Se connesso parte il thread robot
			 * if(systemout) if(systemout)
			 * System.out.println("Robot connesso."); robot= new Thread(new
			 * Robot()); robot.start(); active = true;
			 * btnActivate.setEnabled(false); btnDeactivate.setEnabled(true); }
			 * }
			 * 
			 * });
			 */
			/*
			 * txtCOMvalue.addFocusListener( new FocusAdapter(){ public void
			 * focusLost(java.awt.event.FocusEvent arg0){
			 * 
			 * if(getText().length()==0){btnActivate.setEnabled(false); WinError
			 * wine=new WinError("Errore"); wine.setVisible(true); } else {
			 * portName=getText();btnActivate.setEnabled(true); WinError
			 * wine=new WinError("Porta: "+this.getText());
			 * wine.setVisible(true); } } });
			 */
			add(labelCOM);
			add(txtCOMvalue);
			add(btnActivate);
			// add(btnDeactivate);
			btnActivate.setEnabled(true);
			btnActivate.addActionListener(buttonHandler);
			txtCOMvalue.setText(comtemp);
			// btnDeactivate.addActionListener(buttonHandler);
			// btnDeactivate.setEnabled(false);
		}

		// Azioni dei bottoni della TOOLBAR
		public class ButtonHandler implements ActionListener {
			// Eventi su pulsanti
			public void actionPerformed(ActionEvent e) {
				// Clicco su activate...
				if (!connect) {
					// Visualizza il gene sul campo di testo
					if (systemout)
						System.out.println(genes);
					portName = txtCOMvalue.getText();
					
					if (!connetti(portName)) {
						// if
						// (systemout)System.out.println("Robot non connesso alla porta"+
						// portName);
					} else {
						// Se connesso parte il thread robot

						// if (systemout) System.out.println("Robot connesso.");
						robot = new Thread(new Robot());
						robot.start();
						active = true;
						btnActivate.setText(TXT[25]);
					}
				} else {
					// Clicco su deactivate...
					active = false;
					// disattivo gli ultrasuoni
					// keepUltra=false
					btnActivate.setText(TXT[23]);
					disconnetti();
				}
			}
		}
	}// pannelloRobot

	// Pannello SPACE da usare per separare gli altri pannelli
	class PanelSpace extends JPanel {
		public PanelSpace() {
		}
	}

	// Pannello NORD [Contiene le informazioni generali]
	class PanelNorth extends JPanel {
		public PanelStep pnlStep = null;

		public PanelNorth() {
			setPreferredSize(new Dimension(WIDTH, 100));
			setLayout(new BorderLayout(10, 10));
			JPanel general = new PanelGeneral();
			pnlStep = new PanelStep();
			if (savedMap) {
				add(general, BorderLayout.CENTER);
				add(pnlStep, BorderLayout.EAST);
			} else {
				add(general, BorderLayout.WEST);
				add(pnlStep, BorderLayout.CENTER);
			}
		}
	}// pannelloNord

	// Pannello CENTRO [Contiene la toolbar, l'area attiva per disegnare la
	// mappa e le info sulla posizione del cursore oppure la mappa con il robot
	// in movimento e le informazioni sul movimento]
	class PanelCenter extends JPanel {
		public PanelCenter() {
			setLayout(new BorderLayout(10, 10));
			if (!savedMap)
				add(pnlTool, BorderLayout.WEST);
			pnlEnvironment = new PanelEnvironment();
			add(pnlEnvironment, BorderLayout.CENTER);
		}
	}// pannelloCentro

	// Barra MENU
	public JMenuBar createMenuBar() {
		JMenuBar menuBar;
		JMenu menu, submenu;
		JMenuItem menuItem;

		// Creo il Menu bar
		menuBar = new JMenuBar();

		// Costruisco il menu FILE
		menu = new JMenu("File");
		menu.getAccessibleContext().setAccessibleDescription("Save, Load and Exit");
		menuBar.add(menu);
		if (!savedMap) {
			menuItem = new JMenuItem("Save", createImageIcon("images/saveFile.png"));
			menuItem.setMnemonic(KeyEvent.VK_S);
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
			menuItem.getAccessibleContext().setAccessibleDescription("Save or Load a MapFile");
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					fc = new JFileChooser();
					int returnVal = fc.showSaveDialog(gui);
					if (returnVal == JFileChooser.APPROVE_OPTION) {
						File file = fc.getSelectedFile();
						newSimul.saveMatrix(file.getAbsolutePath());
					}
				}
			});

			menu.add(menuItem);
			menuItem = new JMenuItem("Load", createImageIcon("images/loadFile.png"));
			menuItem.setMnemonic(KeyEvent.VK_L);
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L, ActionEvent.CTRL_MASK));
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					fc = new JFileChooser();
					int returnVal = fc.showOpenDialog(gui);
					if (returnVal == JFileChooser.APPROVE_OPTION) {
						File file = fc.getSelectedFile();
						updateCompOnMatrixLoad(file.getAbsolutePath());
					}
				}
			});
			menu.add(menuItem);
			menu.addSeparator();
		}
		menuItem = new JMenuItem("Exit", createImageIcon("images/exit.png"));
		menuItem.setMnemonic(KeyEvent.VK_X);
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q, ActionEvent.CTRL_MASK));
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);
			}
		});
		menu.add(menuItem);

		// Costruisco il menu SIMULATOR
		if (savedMap) {
			menu = new JMenu("Simulator");
			menu.setMnemonic(KeyEvent.VK_A);
			menu.getAccessibleContext().setAccessibleDescription("Modify parameters of GA");
			menuBar.add(menu);

			submenu = new JMenu("Crossover");
			ButtonGroup groupC = new ButtonGroup();
			radioItem1 = new JRadioButtonMenuItem("One point");
			if(crossoverType==1)radioItem1.setSelected(true);
			else radioItem1.setSelected(false);
			radioItem1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem1.isSelected())
						crossoverType = 1;
					if (systemout)
						System.out.println("SELECTED One Point Crossover");
				}
			});
			groupC.add(radioItem1);
			submenu.add(radioItem1);
			radioItem2 = new JRadioButtonMenuItem("Two point");
			if(crossoverType==2)radioItem2.setSelected(true);
			else radioItem2.setSelected(false);
			radioItem2.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem2.isSelected())
						crossoverType = 2;
					if (systemout)
						System.out.println("SELECTED Two Point Crossover");
				}
			});
			groupC.add(radioItem2);
			submenu.add(radioItem2);
			radioItem3 = new JRadioButtonMenuItem("First type uniform");
			if(crossoverType==3)radioItem3.setSelected(true);
			else radioItem3.setSelected(false);
			radioItem3.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem3.isSelected())
						crossoverType = 3;
					if (systemout)
						System.out.println("SELECTED First Type Uniform Crossover");
				}
			});
			groupC.add(radioItem3);
			submenu.add(radioItem3);
			radioItem4 = new JRadioButtonMenuItem("Secondo type uniform");
			if(crossoverType==4)radioItem4.setSelected(true);
			else radioItem4.setSelected(false);
			radioItem4.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem4.isSelected())
						crossoverType = 4;
					if (systemout)
						System.out.println("SELECTED Secondo Type Uniform Crossover");
				}
			});
			groupC.add(radioItem4);
			submenu.add(radioItem4);
			menu.add(submenu);

			// MATING POOL
			submenu = new JMenu("Mating Pool");
			ButtonGroup groupMP = new ButtonGroup();
			radioItem5 = new JRadioButtonMenuItem("Rank-Based");
			if(selectionType==3)radioItem5.setSelected(true);
			else radioItem5.setSelected(false);
			radioItem5.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem5.isSelected())
						selectionType = 3;
					if (systemout)
						System.out.println("SELECTED Rank-Based Mating Pool");
				}
			});
			groupMP.add(radioItem5);
			submenu.add(radioItem5);

			radioItem6 = new JRadioButtonMenuItem("Roulette");
			if(selectionType==1)radioItem6.setSelected(true);
			else radioItem6.setSelected(false);
			radioItem6.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem6.isSelected())
						selectionType = 1;
					if (systemout)
						System.out.println("SELECTED Roulette Mating Pool");
				}
			});
			groupMP.add(radioItem6);
			submenu.add(radioItem6);
			
			radioItem7 = new JRadioButtonMenuItem("Tournament");
			if(selectionType==2)radioItem7.setSelected(true);
			else radioItem7.setSelected(false);
			radioItem7.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem7.isSelected())
						selectionType = 2;
					if (systemout)
						System.out.println("SELECTED Tournament Mating Pool");
				}
			});
			groupMP.add(radioItem7);
			submenu.add(radioItem7);
			menu.add(submenu);

			// MUTATION
			submenu = new JMenu("Mutation");
			ButtonGroup groupM = new ButtonGroup();
			radioItem8 = new JRadioButtonMenuItem("Simple");
			if(mutationType==1)radioItem8.setSelected(true);
			else radioItem8.setSelected(false);
			radioItem8.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem8.isSelected())
						mutationType = 1;
					if (systemout)
						System.out.println("SELECTED Simple Mutation");
				}
			});
			groupM.add(radioItem8);
			submenu.add(radioItem8);
			/*
			 * radioItem9 = new JRadioButtonMenuItem("Simple 2");
			 * radioItem9.addActionListener(new ActionListener() { public void
			 * actionPerformed(ActionEvent arg0) { if (radioItem9.isSelected())
			 * //MANCA mutationType=2; if(systemout)
			 * System.out.println("SELECTED Simple 2 Mutation"); } });
			 * groupM.add(radioItem9); submenu.add(radioItem9);
			 */
			
			radioItem10 = new JRadioButtonMenuItem("Uniform");
			if(mutationType==3)radioItem10.setSelected(true);
			else radioItem10.setSelected(false);
			radioItem10.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem10.isSelected())
						mutationType = 3;
					if (systemout)
						System.out.println("SELECTED Uniform Mutation");
				}
			});
			groupM.add(radioItem10);
			submenu.add(radioItem10);
			menu.add(submenu);

//			// Fitness
//			submenu = new JMenu("Fitness Function");
//			ButtonGroup groupF = new ButtonGroup();
//			radioItem14 = new JRadioButtonMenuItem("Simple");
//			if(ffType==0)
//			radioItem14.setSelected(true);
//			else
//				radioItem14.setSelected(false);
//			radioItem14.addActionListener(new ActionListener() {
//				public void actionPerformed(ActionEvent arg0) {
//					if (radioItem14.isSelected())
//						ffType = 0;
//					if (systemout)
//						System.out.println("SELECTED Simple FF");
//				}
//			});
//			groupF.add(radioItem14);
//			submenu.add(radioItem14);
//			/*
//			 * radioItem9 = new JRadioButtonMenuItem("Simple 2");
//			 * radioItem9.addActionListener(new ActionListener() { public void
//			 * actionPerformed(ActionEvent arg0) { if (radioItem9.isSelected())
//			 * //MANCA mutationType=2; if(systemout)
//			 * System.out.println("SELECTED Simple 2 Mutation"); } });
//			 * groupM.add(radioItem9); submenu.add(radioItem9);
//			 */
//			radioItem15 = new JRadioButtonMenuItem("Complex");
//			if(ffType==1)
//				radioItem15.setSelected(true);
//			else
//				radioItem15.setSelected(false);
//			radioItem15.addActionListener(new ActionListener() {
//				public void actionPerformed(ActionEvent arg0) {
//					if (radioItem15.isSelected())
//						ffType = 1;
//					if (systemout)
//						System.out.println("SELECTED Complex FF");
//				}
//			});
//			groupF.add(radioItem15);
//			submenu.add(radioItem15);
//
//			menu.add(submenu);
			radioItem13 = new JRadioButtonMenuItem("Social agents");
			if (social)
				radioItem13.setSelected(true);
			else
				radioItem13.setSelected(false);
			radioItem13.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem13.isSelected())
						social = true;
					else
						social = false;
					if (systemout)
						System.out.println("SELECTED Social interaction");
				}
			});
			menu.add(radioItem13);
			radioItem16 = new JRadioButtonMenuItem("GPS");
			if (gps)
				radioItem16.setSelected(true);
			else
				radioItem16.setSelected(false);
			radioItem16.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem16.isSelected())
						gps= true;
					else
						gps = false;
					if (systemout)
						System.out.println("SELECTED GPS");
				}
			});
			menu.add(radioItem16);

			// Costruisco il pulsante ABORT
			menuItem = new JMenuItem("Abort", createImageIcon("images/back.png"));
			menuItem.setToolTipText("Returns to map editor and empty map.");
			menuItem.setMnemonic(KeyEvent.VK_B);
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, ActionEvent.CTRL_MASK));
			menuItem.getAccessibleContext().setAccessibleDescription("Abort simulation");
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					comtemp=txtCOMvalue.getText();
					acqtemp=Integer.parseInt(txtAcquisStep.getText());
					pcrosstemp=Integer.parseInt(txtPCrossvalue.getText());
					pmutatemp= Integer.parseInt(txtPMutavalue.getText()) ;
					steptemp=Integer.parseInt(txtStepvalue.getText());
					savedMap = false;
					savedStart = false;
					savedGoal = false;
					abort = true;
					newSimul = new SimulationData();
					width=gui.getWidth();
					height=gui.getHeight();
					panx=gui.getX();
					pany=gui.getY();
					gui.setVisible(false);
					gui = new GAMP();
					gui.setVisible(true);

				}
			});
			menu.add(menuItem);

		}
		// Costruisco il menu VIEW
		menu = new JMenu("View");
		menu.getAccessibleContext().setAccessibleDescription("Detailed output visualization");
		menuBar.add(menu);

		menuItem2 = new JMenuItem("Console", createImageIcon("images/output.png"));
		menuItem2.setToolTipText("Open standard output viewer");
		menuItem2.setMnemonic(KeyEvent.VK_O);
		menuItem2.setEnabled(false);
		menuItem2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				try {
					new Console();
				} catch (IOException e) {
				}
			}
		});

		radioItem11 = new JRadioButtonMenuItem("Show output");
		radioItem11.setToolTipText("Slower");
		if (systemout)
			radioItem11.setSelected(true);
		else
			radioItem11.setSelected(false);
		radioItem11.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (radioItem11.isSelected()) {
					systemout = true;
					menuItem2.setEnabled(true);
				} else {
					systemout = false;
					menuItem2.setEnabled(false);
				}
			}
		});
		if (!radioItem11.isSelected())
			menuItem2.setEnabled(false);
		menu.add(radioItem11);

		menu.add(menuItem2);
		if (savedMap) {
			radioItem12 = new JRadioButtonMenuItem("Optimum");
			radioItem12.setToolTipText("Draw solution.");
			radioItem12.setSelected(false);
			radioItem12.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					if (radioItem12.isSelected()) {
						String opt = OptimumList.calcolaOttimo("matrice.txt");
						if (opt == null) {
							radioItem12.setSelected(false);
							return;
						}
							
						pnlEnvironment.currPath = opt;
						
						// pulisce la visuale prima di aggiungere il percorso
						pnlEnvironment.drawMatrix(pnlEnvironment.getGraphics(), newSimul.envMat);
						pnlEnvironment.drawPath(pnlEnvironment.getGraphics(), opt, pnlEnvironment.showBeyond);
						status.setText("Now viewing: Optimum agent.");
					} else {
						pnlEnvironment.currPath = null;
						pnlEnvironment.drawMatrix(pnlEnvironment.getGraphics(), newSimul.envMat);
						status.setText("");
					}
				}
			});
			menu.add(radioItem12);
		}
		if (savedMap) {
			radioShowBeyond = new JRadioButtonMenuItem("Show beyond goal/fail");
			radioShowBeyond.setToolTipText("Shows the path's positions beyond the goal position of the fail position.");
			if(pnlEnvironment.showBeyond)
				radioShowBeyond.setSelected(true);
			else 
				radioShowBeyond.setSelected(false);
			radioShowBeyond.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (radioShowBeyond.isSelected())
						pnlEnvironment.showBeyond = true;
					else
						pnlEnvironment.showBeyond = false;
					if (pnlEnvironment.currPath == null)
						return;
					pnlEnvironment.drawMatrix(pnlEnvironment.getGraphics(), newSimul.envMat);
					pnlEnvironment.drawPath(pnlEnvironment.getGraphics(), pnlEnvironment.currPath, pnlEnvironment.showBeyond);
				}
			});
			menu.add(radioShowBeyond);

		}
		// Costruisco il menu ?.
		menu = new JMenu("?");
		menu.getAccessibleContext().setAccessibleDescription("GAMP A.I. Project");
		menuBar.add(menu);

		menuItem = new JMenuItem("About");
		menuItem.setMnemonic(KeyEvent.VK_A);
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				About about = new About();
				about.setVisible(true);
			}
		});

		menu.add(menuItem);
		menuItem = new JMenuItem("Help");
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// apro l'help in formato HTML sul default browser
				BrowserControl.displayURL("help.htm");
			}
		});
		menuItem.setMnemonic(KeyEvent.VK_H);
		menu.add(menuItem);
		return menuBar;
	}

	protected static ImageIcon createImageIcon(String path) {
		java.net.URL imgURL = GAMP.class.getResource(path);
		if (imgURL != null) {
			return new ImageIcon(imgURL);
		} else {
			System.err.println("Couldn't find file: " + path);
			return null;
		}
	}

	// Finestra di ABOUT
	class About extends JFrame {
		// Titolo
		public About() {
			super("About");
			// Grandezza finestra
			setBounds(10, 10, 420, 100);
			// Disegno layout
			setLayout(new FlowLayout());
			JLabel aboutTxt1 = new JLabel("GAMP: Genetic Algorithm for Motion Planning          ");
			aboutTxt1.setFont(new Font("Tahoma", Font.BOLD, 14));
			JLabel aboutTxt2 = new JLabel("Nicola Carlon");
			JLabel aboutTxt3 = new JLabel("Matteo Finotto");
			JLabel aboutTxt4 = new JLabel("Francesco Fornasiero");
			JLabel aboutTxt5 = new JLabel("Giovanni Melis");
			JLabel aboutTxt6 = new JLabel("Marco Visona'");
			JLabel aboutTxt7 = new JLabel("                                                  ");
			JLabel aboutTxt8 = new JLabel(" A.I. Project A.A. 2008/2009");
			aboutTxt8.setFont(new Font("Tahoma", Font.BOLD, 12));
			add(aboutTxt1);
			add(aboutTxt2);
			add(aboutTxt3);
			add(aboutTxt4);
			add(aboutTxt5);
			add(aboutTxt6);
			add(aboutTxt7);
			add(aboutTxt8);
		}
	}// About

	// Finestra di ERRORE
	class WinError extends JFrame {
		// Titolo
		public WinError(String txt) {
			super("Error");
			// Grandezza finestra
			setBounds(10, 10, txt.length() * 8, 100);
			// Disegno layout
			setLayout(null);
			JLabel errorTxt = new JLabel(txt);
			// errorTxt.setFont(new Font("Tahoma", Font.BOLD, 12));
			errorTxt.setBounds(20, 20, txt.length() * 7, 16);
			btnOk = new JButton("OK");
			btnOk.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// Clicco su Procedi...
					if (e.getSource() == btnOk) {
						// MANCA
						collide = false;
						setVisible(false);
					}
				}
			});
			btnOk.setBounds(txt.length() * 7 - 80, 40, 60, 20);
			add(errorTxt, BorderLayout.CENTER);
			add(btnOk, BorderLayout.EAST);
		}
	}// WinError

	// Finestra di ANIMAZIONE
	class Wait extends JFrame implements Runnable {
		// Titolo
		Wait winW;

		public void run() {
			winW = new Wait();
			winW.setVisible(true);
		}

		public void stop() {
			winW.setVisible(false);
		}

		public Wait() {
			super(TXT[35]);
			setBounds(10, 10, 160, 280);
			setLayout(new FlowLayout());
			animLabel = new JLabel();
			animImage = new ImageIcon(this.getClass().getResource("images/rep.gif"));
			animLabel.setIcon(animImage);
			btnAbort = new JButton("Stop");
			btnAbort.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					stop=true;
					gui.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
//					abort = true;
//					
//					savedStart = false;
//					savedGoal = false;
//					newSimul.flag = 2;
					status.setText(TXT[36]);
//					setVisible(false);
//					savedMap = false;
//					newSimul = new SimulationData();
//					gui.setVisible(false);
//					gui = new GAMP();
//					gui.setVisible(true);
				}

			});
			btnSpeed = new JButton();
			if (systemout) {
				btnSpeed.setText(TXT[37]);
				btnSpeed.setToolTipText(TXT[38]);
			} else {
				btnSpeed.setText(TXT[39]);
				btnSpeed.setToolTipText(TXT[40]);
			}
			btnSpeed.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (systemout) {
						systemout = false;
						btnSpeed.setText(TXT[37]);
					} else {
						systemout = true;
						btnSpeed.setText(TXT[39]);
					}
				}
			});
			add(animLabel);
			add(btnAbort);
			add(btnSpeed);
			animLabel.setVisible(true);
		}
	}// wait

	/****************************************************************************************************************/
	/************************************* E*N*V*I*R*O*M*E*N*T *****************************************************/
	/****************************************************************************************************************/

	class PanelEnvironment extends JPanel {
		public int CELL_SIZE = 20; // dimensione in pixel della singola cella del robot
		public boolean showBeyond = false;
		public String currPath = null;
		private Point topLeftCoord; // coordinate in pixel dell'angolo in alto a
		// sx dell'ambiente del robot
		private Point bottomRightCoord; // coordinate in pixel dell'angolo in
		// basso a dx dell'ambiente del robot
		private Point beginCoord; // coordinate in pixel della posizione iniziale del robot
		private Point lastDrawnCell; // coordinate in pixel dell'ultima cella disegnata
		private Point goalCoord; // coordinate in pixel della posizione del goal
		private byte beginDir; // direzione del robot nella cella iniziale

		private Color backgroundColor = Color.white;
		private Color gridColor = new Color(0, 0, 128);

		// Direzioni delle frecce
		private final int ARROW_N = 0;
		private final int ARROW_E = 1;
		private final int ARROW_S = 2;
		private final int ARROW_W = 3;

		public PanelEnvironment() {
			super();
			setLayout(null);
			if(	initStatus != InitStatus.DONE||abort){this.setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));}
			
			if (initStatus == InitStatus.DEF_BORDERS && !savedMap){
				setToolTipText(TXT[6]);
				status.setText(TXT[6]);
			}
			
			this.setBounds(100, 100, 500, 300);
			this.setBackground(backgroundColor);
			this.addMouseListener(new MouseAdapter() {
				/*
				 * Handler eventi del mouse nel pannello PanelEnvironment
				 * 
				 * @see
				 * java.awt.event.MouseListener#mouseClicked(java.awt.event.
				 * MouseEvent)
				 */
				public void mouseClicked(MouseEvent e) {
					if (e.getX() < topLeftCoord.x || e.getX() > bottomRightCoord.x || e.getY() < topLeftCoord.y || e.getY() > bottomRightCoord.y)
						return;

					if (initStatus == InitStatus.DEF_BEGIN) {

						if (systemout)
							System.out.println("e.getPoint(): " + e.getPoint().x + "\t" + e.getPoint().y);
						int[] point = toArrayIndex(e.getPoint());
						if (newSimul.envMat[point[1]][point[0]] >= SimulationData.matValues.BEGIN_N
								&& newSimul.envMat[point[1]][point[0]] <= SimulationData.matValues.BEGIN_S) {
							setMatrixValue(pnlEnvironment.getGraphics(), e.getPoint(), (byte) (newSimul.envMat[point[1]][point[0]] + 1));
						} else if (newSimul.envMat[point[1]][point[0]] == SimulationData.matValues.BEGIN_W) {
							setMatrixValue(pnlEnvironment.getGraphics(), e.getPoint(), SimulationData.matValues.BEGIN_N);
						} else if (newSimul.envMat[point[1]][point[0]] == SimulationData.matValues.EMPTY) {
							if (newSimul.getRobotStartPos() != null) {
								SimulationData.MatrixCell begin = newSimul.getRobotStartPos();
								setMatrixValue(pnlEnvironment.getGraphics(), toPointCoordinates(begin), SimulationData.matValues.EMPTY);
							}
							setMatrixValue(pnlEnvironment.getGraphics(), e.getPoint(), SimulationData.matValues.BEGIN_N);
						} else
							return;
						savedStart = true;

						beginCoord = new Point(quantize(e.getPoint()));
						beginDir = newSimul.envMat[point[1]][point[0]];

						newSimul.setRobotStartPos(point[0], point[1]);
						if (systemout)
							System.out.println(newSimul.getRobotStartPos().toString());
					} else if (initStatus == InitStatus.DEF_GOAL) {
						if (newSimul.getRobotEndPos() != null) {
							SimulationData.MatrixCell goal = newSimul.getRobotEndPos();
							setMatrixValue(pnlEnvironment.getGraphics(), toPointCoordinates(goal), SimulationData.matValues.EMPTY);
						}

						if (systemout)
							System.out.println("e.getPoint(): " + e.getPoint().x + "\t" + e.getPoint().y);

						int[] point = toArrayIndex(e.getPoint());
						if (newSimul.envMat[point[1]][point[0]] != SimulationData.matValues.EMPTY)
							return;

						setMatrixValue(pnlEnvironment.getGraphics(), e.getPoint(), SimulationData.matValues.GOAL);
						savedGoal = true;
						goalCoord = new Point(quantize(e.getPoint()));
						newSimul.setRobotEndPos(point[0], point[1]);
						if (systemout)
							System.out.println(newSimul.getRobotEndPos().toString());
					} else if (initStatus == InitStatus.DEF_OBSTACLES) {
						if (systemout)
							System.out.println("e.getPoint(): " + e.getPoint().x + "\t" + e.getPoint().y);
						toggleObstacle(e.getPoint());
						// Controllo che la finestra di errore non sia rimasta aperta ed in caso la chiudo
						if (collide) {
							win.setVisible(false);
							collide = false;
						}
					}

					((PanelTools) pnlTool).updateToolButtons();
				}

				public void mousePressed(MouseEvent arg0) {
					if (initStatus == InitStatus.DEF_BORDERS && !savedMap) {
						topLeftCoord = arg0.getPoint();
						if (systemout)
							System.out.println("startPos: " + topLeftCoord.x + "\t" + topLeftCoord.y);
					}
				}

				public void mouseReleased(MouseEvent arg0) {
					if (initStatus == InitStatus.DEF_BORDERS && !savedMap) {
						bottomRightCoord = arg0.getPoint();
						btnCancel.setEnabled(true);
						if (topLeftCoord.equals(bottomRightCoord))
							return;

						// Assicuriamoci che il punto startPos sia quello in
						// alto a sx, mentre l'endPos quello in basso a dx
						Point newStartpos = new Point(Math.min(topLeftCoord.x, bottomRightCoord.x), Math.min(topLeftCoord.y, bottomRightCoord.y));
						Point newEndpos = new Point(Math.max(topLeftCoord.x, bottomRightCoord.x), Math.max(topLeftCoord.y, bottomRightCoord.y));
						topLeftCoord = newStartpos;
						bottomRightCoord = newEndpos;

						Point qStart = quantize(topLeftCoord);
						Point qEnd = quantize(bottomRightCoord);
						int x = (int) (Math.abs(qStart.x - qEnd.x) / CELL_SIZE);
						int y = (int) (Math.abs(qStart.y - qEnd.y) / CELL_SIZE);
						newSimul.initMatrix(x, y);
						newSimul.saveMatrix("matrice.txt");

						try {
							newSimul.loadMatrix("matrice.txt");
						} catch (IOException e) {
							e.printStackTrace();
						}

						btnStart.setEnabled(true);
						btnGoal.setEnabled(true);
						btnObstacle.setEnabled(true);
						perimeter = x + y;
						setToolTipText(null);
						ngenimax = ((newSimul.envMat.length - 1) * (newSimul.envMat[0].length - 1)) / 2;
						txtNGenivalue.setText("" + ngenimax);
						pnlEnvironment.drawMatrix(pnlEnvironment.getGraphics(), newSimul.envMat);
					}
				}
			});

			this.resetLastDrawnCell();
		}

		private void resetLastDrawnCell() {
			lastDrawnCell = null;
		}

		public void paintComponent(Graphics g) {
			super.paintComponent(g);
			if (savedMap) {
				drawMatrix(g, newSimul.envMat);
				if (currPath != null) {
					pnlEnvironment.drawPath(g, currPath, showBeyond);
				}
			} else {
				drawGrid(g);
				if (newSimul.envMat != null)
					drawMatrix(g, newSimul.envMat);
			}
		}

		private void drawGrid(Graphics g) {
			super.paintComponent(g);
			g.setColor(gridColor);
			g.drawLine(0, 0, 0, this.getHeight());
			g.drawLine(0, 0, this.getWidth(), 0);
			g.drawLine(0, this.getHeight() - 1, this.getWidth() - 1, this.getHeight() - 1);
			g.drawLine(this.getWidth() - 1, 0, this.getWidth() - 1, this.getHeight() - 1);

			for (int i = 0; i < this.getWidth(); i += CELL_SIZE) {
				g.drawLine(i, 0, i, this.getHeight());
			}
			for (int j = 0; j < this.getHeight(); j += CELL_SIZE) {
				g.drawLine(0, j, this.getWidth(), j);
			}
		}

		private void drawBorder(Graphics g2, Point topLeftCoord, int width, int height) {
			Graphics2D g = (Graphics2D) g2;
			g.setStroke(new BasicStroke(3f));
			g.setPaint(new GradientPaint(topLeftCoord.x, topLeftCoord.y, Color.darkGray, topLeftCoord.x, topLeftCoord.y + height, Color.black));
			g.drawRect(topLeftCoord.x, topLeftCoord.y, width, height);
			g.setStroke(new BasicStroke(1f));
		}

		private void drawBorder(Graphics g2) {
			Graphics2D g = (Graphics2D) g2;
			topLeftCoord = quantize(topLeftCoord);
			bottomRightCoord = quantize(bottomRightCoord);
			g.setStroke(new BasicStroke(3f));
			int width = Math.abs(topLeftCoord.x - bottomRightCoord.x);
			int height = Math.abs(topLeftCoord.y - bottomRightCoord.y);
			g.setPaint(new GradientPaint(topLeftCoord.x, topLeftCoord.y, Color.darkGray, topLeftCoord.x, topLeftCoord.y + height, Color.black));
			g.drawRect(topLeftCoord.x, topLeftCoord.y, width, height);
			g.setStroke(new BasicStroke(1f));
		}

		private void drawCell(Graphics g2, Point p, byte cellType, boolean redrawBorders, boolean drawTransparent) {
			Graphics2D g = (Graphics2D) g2;

			if (cellType == SimulationData.matValues.EMPTY) { // cella libera
				g.setColor(backgroundColor);
				g.fillRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				g.setColor(gridColor);
				g.drawRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				if (redrawBorders)
					this.drawBorder(g2);
				return;
			} else if (cellType == SimulationData.matValues.OBSTACLE) { // cella
				// occupata
				g.setPaint(new GradientPaint(p.x, p.y, Color.black, p.x, p.y + CELL_SIZE, Color.darkGray));
				g.fillRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				g.setPaint(new GradientPaint(p.x, p.y, Color.darkGray, p.x, p.y + CELL_SIZE, Color.black));
				g.drawRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
			} else if (cellType == SimulationData.matValues.DEATH) { // cella
				// occupata
				g.setPaint(new GradientPaint(p.x, p.y, Color.black, p.x, p.y + CELL_SIZE, Color.red));
				g.fillRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				g.setPaint(new GradientPaint(p.x, p.y, Color.darkGray, p.x, p.y + CELL_SIZE, Color.black));
				g.drawRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
			} else if (cellType == SimulationData.matValues.BEGIN_N) { // cella
				// begin
				g.setPaint(new GradientPaint(p.x, p.y, Color.green, p.x, p.y + CELL_SIZE, new Color(0, 192, 0)));
				g.fillRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				g.setPaint(new GradientPaint(p.x, p.y, new Color(0, 192, 0), p.x, p.y + CELL_SIZE, Color.green));
				g.drawRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				drawArrow(g2, p, ARROW_N, false);
			} else if (cellType == SimulationData.matValues.BEGIN_S) { // cella
				// begin
				g.setPaint(new GradientPaint(p.x, p.y, Color.green, p.x, p.y + CELL_SIZE, new Color(0, 192, 0)));
				g.fillRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				g.setPaint(new GradientPaint(p.x, p.y, new Color(0, 192, 0), p.x, p.y + CELL_SIZE, Color.green));
				g.drawRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				drawArrow(g2, p, ARROW_S, false);
			} else if (cellType == SimulationData.matValues.BEGIN_W) { // cella
				// begin
				g.setPaint(new GradientPaint(p.x, p.y, Color.green, p.x, p.y + CELL_SIZE, new Color(0, 192, 0)));
				g.fillRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				g.setPaint(new GradientPaint(p.x, p.y, new Color(0, 192, 0), p.x, p.y + CELL_SIZE, Color.green));
				g.drawRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				drawArrow(g2, p, ARROW_W, false);
			} else if (cellType == SimulationData.matValues.BEGIN_E) { // cella
				// begin
				g.setPaint(new GradientPaint(p.x, p.y, Color.green, p.x, p.y + CELL_SIZE, new Color(0, 192, 0)));
				g.fillRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				g.setPaint(new GradientPaint(p.x, p.y, new Color(0, 192, 0), p.x, p.y + CELL_SIZE, Color.green));
				g.drawRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				drawArrow(g2, p, ARROW_E, false);
			} else if (cellType == SimulationData.matValues.GOAL) { // cella
				// goal
				g.setPaint(new GradientPaint(p.x, p.y, Color.red, p.x, p.y + CELL_SIZE, new Color(192, 0, 0)));
				g.fillRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				g.setPaint(new GradientPaint(p.x, p.y, new Color(192, 0, 0), p.x, p.y + CELL_SIZE, Color.red));
				g.drawRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
			} else if (cellType >= SimulationData.matValues.PATH_N && cellType <= SimulationData.matValues.PATH_W) {
				if (drawTransparent)
					g.setPaint(new GradientPaint(p.x, p.y, new Color(255, 255, 255, 128), p.x, p.y + CELL_SIZE, new Color(200, 200, 200, 128)));
				else
					g.setPaint(new GradientPaint(p.x, p.y, Color.white, p.x, p.y + CELL_SIZE, Color.lightGray));
				g.fillRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
				g.setPaint(new GradientPaint(p.x, p.y, Color.lightGray, p.x, p.y + CELL_SIZE, Color.white));
				g.drawRect(p.x, p.y, CELL_SIZE, CELL_SIZE);
			}

			if (redrawBorders)
				this.drawBorder(g2);
			lastDrawnCell = new Point(p.x, p.y);
		}

		private void drawMatrix(Graphics g2, byte[][] mat) {
			// centrare l'ambiente nell'area visibile
			Dimension dim = this.getSize();
			Point topLeft = new Point((dim.width - mat[0].length * CELL_SIZE) / 2, (dim.height - mat.length * CELL_SIZE) / 2);
			topLeft = quantize(topLeft);
			drawGrid(g2);

			Point curr;
			topLeftCoord = topLeft;
			bottomRightCoord = new Point(topLeft.x + CELL_SIZE * mat[0].length, topLeft.y + CELL_SIZE * mat.length);
			beginCoord = new Point();
			goalCoord = new Point();
			for (int i = 0; i < mat.length; i++) {

				for (int j = 0; j < mat[i].length; j++) {
					curr = new Point(topLeft.x + CELL_SIZE * j, topLeft.y + CELL_SIZE * i);
					if (mat[i][j] >= SimulationData.matValues.BEGIN_N && mat[i][j] <= SimulationData.matValues.BEGIN_W) {
						beginCoord.x = topLeft.x + j * CELL_SIZE;
						beginCoord.y = topLeft.y + i * CELL_SIZE;
					} else if (mat[i][j] == SimulationData.matValues.GOAL) {
						goalCoord.x = topLeft.x + j * CELL_SIZE;
						goalCoord.y = topLeft.y + i * CELL_SIZE;
					}
					drawCell(g2, curr, mat[i][j], false, false);
				}
			}
			drawBorder(g2, topLeft, mat[0].length * CELL_SIZE, mat.length * CELL_SIZE);
		}

		/**
		 * Disegna una freccia nella cella indicata
		 * 
		 * @param cell
		 * @param direction
		 *            : uno dei 4 valori ARROW_N, ARROW_S, ARROW_W, ARROW_E
		 */
		private void drawArrow(Graphics g2, Point cell, int direction, boolean drawTransparent) {
			Graphics2D g = (Graphics2D) g2;// this.getGraphics();
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			if (drawTransparent)
				g.setColor(new Color(0, 0, 128, 128));
			else
				g.setColor(new Color(0, 0, 128, 255));

			g.setStroke(new BasicStroke(CELL_SIZE / 5, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
			switch (direction) {
			case ARROW_N:
				g.fillOval(cell.x + (CELL_SIZE - CELL_SIZE / 3) / 2, cell.y + CELL_SIZE / 2, CELL_SIZE / 3, CELL_SIZE / 3);
				int[] xPoints1 = { cell.x + CELL_SIZE / 4, cell.x + CELL_SIZE / 2, cell.x + CELL_SIZE - CELL_SIZE / 4 };
				int[] yPoints1 = { cell.y + CELL_SIZE / 2, cell.y + CELL_SIZE / 4, cell.y + CELL_SIZE / 2 };
				g.drawPolyline(xPoints1, yPoints1, 3);
				break;
			case ARROW_S:
				g.fillOval(cell.x + (CELL_SIZE - CELL_SIZE / 3) / 2, cell.y + CELL_SIZE / 2 - CELL_SIZE / 3, CELL_SIZE / 3, CELL_SIZE / 3);
				int[] xPoints2 = { cell.x + CELL_SIZE / 4, cell.x + CELL_SIZE / 2, cell.x + CELL_SIZE - CELL_SIZE / 4 };
				int[] yPoints2 = { cell.y + CELL_SIZE / 2, cell.y + CELL_SIZE - CELL_SIZE / 4, cell.y + CELL_SIZE / 2 };
				g.drawPolyline(xPoints2, yPoints2, 3);
				break;
			case ARROW_W:
				g.fillOval(cell.x + CELL_SIZE / 2, cell.y + (CELL_SIZE - CELL_SIZE / 3) / 2, CELL_SIZE / 3, CELL_SIZE / 3);
				int[] yPoints3 = { cell.y + CELL_SIZE / 4, cell.y + CELL_SIZE / 2, cell.y + CELL_SIZE - CELL_SIZE / 4 };
				int[] xPoints3 = { cell.x + CELL_SIZE / 2, cell.x + CELL_SIZE / 4, cell.x + CELL_SIZE / 2 };
				g.drawPolyline(xPoints3, yPoints3, 3);
				break;
			case ARROW_E:
				g.fillOval(cell.x + CELL_SIZE / 2 - CELL_SIZE / 3, cell.y + (CELL_SIZE - CELL_SIZE / 3) / 2, CELL_SIZE / 3, CELL_SIZE / 3);
				int[] yPoints4 = { cell.y + CELL_SIZE / 4, cell.y + CELL_SIZE / 2, cell.y + CELL_SIZE - CELL_SIZE / 4 };
				int[] xPoints4 = { cell.x + CELL_SIZE / 2, cell.x + CELL_SIZE - CELL_SIZE / 4, cell.x + CELL_SIZE / 2 };
				g.drawPolyline(xPoints4, yPoints4, 3);
				break;
			default:
				g.setColor(new Color(255, 0, 0, 255));
				g.fillOval(cell.x + (CELL_SIZE - CELL_SIZE / 3) / 2, cell.y + (CELL_SIZE - CELL_SIZE / 3) / 2, CELL_SIZE / 3, CELL_SIZE / 3);
				break;
			}
			g.setStroke(new BasicStroke(1f));
		}

		private void drawPath(Graphics g2, String path, boolean drawUselessMoves) {
			SimulationData.MatrixCell begin = newSimul.getRobotStartPos();
			int currDirection = newSimul.envMat[begin.y][begin.x] - 2;
			// conversione da valore della cella di inizio a valore della direzione nel path
			// mappata nel range di valori [0, 4] che e' quello dei valori accettati dal metodo drawArrow
			Point currCoordinates = new Point(beginCoord.x, beginCoord.y);
			SimulationData.MatrixCell currCell = newSimul.new MatrixCell(begin.x, begin.y);
			char currChar;
			boolean lastChar = false;
			boolean drawTransparent = false;
			for (int i = 0; i < path.length(); i++) {
				currChar = path.charAt(i);
				switch (currChar) {
				case 'A':
					// la direzione non cambia bisogna solo indicare le
					// coordinate della nuova cella
					break;
				case 'S':
					// la direzione cambia in senso antiorario
					currDirection = (currDirection + 4 - 1) % 4;
					break;
				case 'D':
					currDirection = (currDirection + 1) % 4;
					break;
				}
				if (currDirection + 7 == SimulationData.matValues.PATH_N) {
					currCoordinates.y -= CELL_SIZE;
					currCell.y--;
				} else if (currDirection + 7 == SimulationData.matValues.PATH_E) {
					currCoordinates.x += CELL_SIZE;
					currCell.x++;
				} else if (currDirection + 7 == SimulationData.matValues.PATH_S) {
					currCoordinates.y += CELL_SIZE;
					currCell.y++;
				} else if (currDirection + 7 == SimulationData.matValues.PATH_W) {
					currCoordinates.x -= CELL_SIZE;
					currCell.x--;
				}
				// se siamo all'ulimo carattere ridisegnamo i bordi
				// dell'ambiente impostando a true la variabile
				if (i == path.length() - 1)
					lastChar = true;

				try {
					// se siamo giunti su un ostacolo disegna le prossime celle
					// in modo semi trasparente
					if (newSimul.envMat[currCell.y][currCell.x] == SimulationData.matValues.OBSTACLE
							|| newSimul.envMat[currCell.y][currCell.x] == SimulationData.matValues.DEATH)
						drawTransparent = true;
					// se siamo giunti su un ostacolo e non vogliamo disegnare
					// ulteriori celle esci dal metodo
					if ((newSimul.envMat[currCell.y][currCell.x] == SimulationData.matValues.OBSTACLE || 
							newSimul.envMat[currCell.y][currCell.x] == SimulationData.matValues.DEATH)
							&& !drawUselessMoves) {
						drawArrow(g2, currCoordinates, 5, drawTransparent);
						return;
					}
				} catch (ArrayIndexOutOfBoundsException e) {
					drawTransparent = true;
					if (!drawUselessMoves) {
						drawArrow(g2, currCoordinates, 5, drawTransparent);
						return;
					}
				}

				// se siamo giunti al goal disegna le prossime celle in modo
				// semi trasparente
				if (currCoordinates.equals(goalCoord)) {
					drawTransparent = true;
				}

				drawCell(g2, currCoordinates, (byte) (currDirection + 7), lastChar, drawTransparent);
				drawArrow(g2, currCoordinates, currDirection, drawTransparent);

				// se siamo giunti al goal e non vogliamo disegnare ulteriori
				// celle esci dal metodo
				if (currCoordinates.equals(goalCoord) && !drawUselessMoves)
					return;
			}
		}

		private Point quantize(Point p) {
			return new Point((int) p.getX() - (int) p.getX() % CELL_SIZE, (int) p.getY() - (int) p.getY() % CELL_SIZE);
		}

		private void setMatrixValue(Graphics g, Point p, byte cellType) {
			Point qp = quantize(p);
			int temp[] = toArrayIndex(qp);
			int qx = temp[0]; // conversione da pixel a indice matrice
			int qy = temp[1]; // conversione da pixel a indice matrice

			if (!qp.equals(lastDrawnCell) && 
					(newSimul.envMat[qy][qx] >= SimulationData.matValues.BEGIN_N && 
					newSimul.envMat[qy][qx] <= SimulationData.matValues.BEGIN_W || 
					newSimul.envMat[qy][qx] == SimulationData.matValues.GOAL))
				return;
			if ((newSimul.envMat[qy][qx] >= SimulationData.matValues.BEGIN_N && 
					newSimul.envMat[qy][qx] <= SimulationData.matValues.BEGIN_W || 
					newSimul.envMat[qy][qx] == SimulationData.matValues.GOAL)
					&& initStatus == InitStatus.DEF_OBSTACLES)
				return;

			newSimul.envMat[qy][qx] = cellType;
			drawCell(g, qp, cellType, true, true);
		}

		/**
		 * Svolge il lavoro opposto della funzione toArrayIndex, ovvero converte 
		 * una casella della matrice in coordinate in pixel.
		 * @param m coordinate sotto forma di indici di matrice
		 * @return  coordinate in pixel
		 */
		private Point toPointCoordinates(SimulationData.MatrixCell m) {
			return new Point(topLeftCoord.x + m.x * CELL_SIZE, topLeftCoord.y + m.y * CELL_SIZE);
		}

		/**
		 * Converte una coordinata in pixel in una cella della matrice sotto forma 
		 * di array di int da 2 elementi in cui il primo corrisponde all'ascissa
		 * e il secondo all'ordinata.
		 * @param p
		 * @return
		 */
		private int[] toArrayIndex(Point p) {
			Point qp = quantize(p);
			int[] q = { qp.x / CELL_SIZE - topLeftCoord.x / CELL_SIZE, qp.y / CELL_SIZE - topLeftCoord.y / CELL_SIZE };
			return q;
		}

		private void toggleObstacle(Point p) {
			Point qp = quantize(p);
			int[] temp = toArrayIndex(p);
			int qx = temp[0];
			int qy = temp[1];

			if (newSimul.envMat[qy][qx] == SimulationData.matValues.EMPTY)
				setMatrixValue(this.getGraphics(), qp, SimulationData.matValues.OBSTACLE);
			else if (newSimul.envMat[qy][qx] == SimulationData.matValues.OBSTACLE)
				setMatrixValue(this.getGraphics(), qp, SimulationData.matValues.EMPTY);
		}
	}// end class PanelEnvironment

	public class Simulator implements Runnable {
		public void run() {
			// Algoritmo Genetico
			// newSimul.currGeneration+=Integer.parseInt(txtStepvalue.getText());
			// pnlOut.animLabel.setVisible(true);
			// pnlOut.txtInfoValue.setVisible(false);
			// Wait winW = new Wait();
			// winW.run();
			newSimul.setNGenes(Integer.parseInt(txtNGenivalue.getText()));
			newSimul.setNIndiv(Integer.parseInt(txtNIndvalue.getText()));

			if (newSimul.getNGenerations() == 0)
				newSimul.initSimulation();

			// se non ho avuto il culo di trovare la soluzione nella fase di
			// inizializzazione della simulazione continua con quelle successive
			double pcross = ((double) Integer.parseInt(txtPCrossvalue.getText()) / 100);
			double pmuta = ((double) Integer.parseInt(txtPMutavalue.getText()) / 100);
			
			if (pcross > 1) {
				txtPCrossvalue.setText("100");
				pcross = 1;
			}
			if (pmuta > 1) {
				txtPMutavalue.setText("100");
				pmuta = 1;
			}
			
			if (systemout)
				System.out.println("------->PCrossover: " + pcross + " PMutate: " + pmuta);
			if (newSimul.getSolution() == null && !abort)
				newSimul.calcNextGenerations(
						Integer.parseInt(txtStepvalue.getText()), selectionType, crossoverType, pcross, mutationType, pmuta);

			if (!abort)
				updateComboBoxes();
			if (newSimul.getSolution() != null) {
				if (systemout)
					if (systemout)
						System.out.println("SOLUZIONE!!!!!!!!!");
				btnActivate.setEnabled(true);
				genes = newSimul.getSolution().getChromosome().substring(0, Move.ngenesbeforegoal);
				status.setText(newSimul.getSolution().getChromosome());
				pnlEnvironment.currPath = newSimul.getSolution().getChromosome();
				pnlEnvironment.drawPath(pnlEnvironment.getGraphics(), pnlEnvironment.currPath, pnlEnvironment.showBeyond);
				double optimum = 1;
				
				String a = OptimumList.calcolaOttimo("matrice.txt");
				if (a == null) return;
				
				optimum = (double) a.length();
				double proximity = (optimum / (double) Move.ngenesbeforegoal) * 100;
				BigDecimal bg = new BigDecimal(proximity);
				bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
				proximity = bg.doubleValue();

				txtNGoalvalue.setText("" + proximity);
				if (systemout)
					System.out.println("GENE RISOLUTORE: " + newSimul.getSolution().getChromosome());
				status.setText(TXT[34] + "Now viewing agent " + newSimul.getSolution().getChromosome() + 
						" | #Gen: " + (newSimul.currGeneration - 1)
						+ " | FF: " + newSimul.getSolution().getFitness());
			} else
				status.setText(TXT[34]);

			txtNGenValue.setText("" + (newSimul.currGeneration - 1));
			winAnimation.setVisible(false);
			gui.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
		}
	}

	/****************************************************************************************************************/
	/******************************************* R*O*B*O*T ***********************************************************/
	/****************************************************************************************************************/

	// Thread ROBOT
	public class Robot implements Runnable {
		public void run() {
			mov = new MovControl(internal);
			// us = new USControl(internal);
			// us.activateUS();
			// Attivo Thread ULTRASUONI
			// ultra= new Thread(new Ultra());
			// ultra.start();
			// MOVIMENTI
			try {
				// Parsing GENI
				for (int i = 0; i < genes.length(); i++) {
					char c = genes.charAt(i);
						System.out.print(c);
					// AVANTI
					if (c == 'A') {
						mov.forward();
						System.out.print("vanti...");
						Thread.sleep(2200);
						System.out.println("fatto");
						
						
					}
					// SINISTRA
					if (c == 'S') {
					System.out.print("inistra:");
						mov.backward();
						System.out.print(" indietro...");
						Thread.sleep(1000);
						System.out.print("fatto-");
						
						
						mov.left();
						System.out.print(" ruota...");
						Thread.sleep(2000);
						System.out.print("fatto-");
						
						
						mov.forward();
						System.out.print(" avanti mezzo...");
						Thread.sleep(1000);
						System.out.print("fatto-");
						
						
						mov.forward();
						System.out.print(" avanti...");
						Thread.sleep(2200);
						System.out.println(" fatto");
						
						
					}
					// DESTRA
					if (c == 'D') {
						System.out.print("estra:");
						mov.backward();
						System.out.print(" indietro...");
						Thread.sleep(1000);
						System.out.print("fatto-");
						
						
						mov.right();
						System.out.print(" ruota...");
						Thread.sleep(2000);
						System.out.print("fatto-");
						
						
						mov.forward();
						System.out.print(" avanti mezzo...");
						Thread.sleep(1000);
						System.out.print("fatto-");
						
						
						mov.forward();
						System.out.print(" avanti...");
						Thread.sleep(2200);
						System.out.println(" fatto");
						
						
					}

				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			System.out.print("Stop");
			// keepUltra=false;
			// us.deactivateUS();
			btnActivate.setText(TXT[23]);
			active = false;
			disconnetti();
		}
		// run
	}// Tread Robot

	/*
	 * Tread ULTRASUONI public class Ultra implements Runnable { int[] v = new
	 * int[3]; public void run() { us.activateUS(); while(keepUltra) { v =
	 * us.getAll(); //DEBUG if(systemout) System.out.println("Ultrasuoni: "+v[0]
	 * + " - "+v[1]+ " - "+v[2]);
	 * if((v[0]<ULTRA_MAX&&v[0]>5)&&(v[1]<ULTRA_MAX&&v
	 * [1]>5)||(v[1]<ULTRA_MAX&&v[1]>5)&&(v[2]<ULTRA_MAX&&v[2]>5)) { //MURO!
	 * //DEBUG if(systemout) System.out.println("Muro!"); } try {
	 * Thread.sleep(ULTRA_REFRESH); } catch (Exception e) { e.printStackTrace();
	 * }
	 * 
	 * } us.deactivateUS(); } } // Tread Ultra;
	 */

	// CONNESSIONE
	public boolean connetti(String port) {
		connect = true;
		ConnectionProvider provider = new SerialJavaxCommProvider(port, 9600);
		protocol = new ProtocolHandler(provider, 9600);
		internal = new InternalHandler();
		protocol.addCapabilityHandler(internal);

		if (systemout)
			System.out.println("Connecting...");
		try {
			if (!protocol.connect()) {
				win = new WinError(TXT[17] + port);
				win.setVisible(true);
				connect = false;
				return false;
			}
			if (!protocol.setup(5000)) {
				win = new WinError(TXT[18]);
				win.setVisible(true);
				protocol.disconnect(true);
				connect = false;
				return false;
			}
		} catch (Exception e) {
			e.printStackTrace();
			connect = false;
			return false;
		}
		if (systemout)
			System.out.println("Connected!");

		return true;
	} // connetti()

	// DISCONNESSIONE
	public void disconnetti() {

		if (systemout)
			System.out.println("Disconnecting...");
		try {
			protocol.disconnect(false);
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}
		if (systemout)
			System.out.println("Disconnected!");
		connect=false;
	} // disconnetti()

	public void generateMap(int righe, int colonne, int ostacoli, String tipo) {

		byte[][] mappa = new byte[righe][colonne];
		for (int i = 0; i < righe; i++)
			for (int j = 0; j < colonne; j++)
				if (i == 0 || j == 0 || j == colonne - 1 || i == righe - 1)
					mappa[i][j] = SimulationData.matValues.OBSTACLE;
		// Mappa a chiocciola
		// Start in alto a sinistra orientato verso est
		// Goal nel centro della mappa
		if (tipo.equals("C")) {
			mappa[1][1] = SimulationData.matValues.BEGIN_E;
			mappa[(righe) / 2][(colonne - 1) / 2] = SimulationData.matValues.GOAL;
			int up = 2;
			int down = righe - 3;
			int sx = 2;
			int dx = colonne - 3;
			for (int j = 0; j <= dx; j++)
				if (mappa[up][j] != SimulationData.matValues.GOAL)
					mappa[up][j] = SimulationData.matValues.OBSTACLE;
				else
					break;

			while (true) {
				for (int j = up; j <= down; j++)
					if (mappa[j][dx] != SimulationData.matValues.GOAL)
						mappa[j][dx] = SimulationData.matValues.OBSTACLE;
					else
						break;
				up = up + 2;

				if (up > down || sx > dx)
					break;

				for (int j = dx; j >= sx; j--)
					if (mappa[down][j] != SimulationData.matValues.GOAL)
						mappa[down][j] = SimulationData.matValues.OBSTACLE;
					else
						break;
				dx = dx - 2;

				if (up > down || sx > dx)
					break;

				for (int j = down; j >= up; j--)
					if (mappa[j][sx] != SimulationData.matValues.GOAL)
						mappa[j][sx] = SimulationData.matValues.OBSTACLE;
					else
						break;
				down = down - 2;

				if (up > down || sx > dx)
					break;

				for (int j = sx; j <= dx; j++)
					if (mappa[up][j] != SimulationData.matValues.GOAL)
						mappa[up][j] = SimulationData.matValues.OBSTACLE;
					else
						break;
				sx = sx + 2;

				if (up > down || sx > dx)
					break;
			}
		}

		// Mappa a serpentina
		// Start in alto a sinistra orientato verso est
		// Goal nell'ultima riga nella posizione raggiungibile con pi=F9 passi
		else if (tipo.equals("S")) {
			mappa[1][1] = SimulationData.matValues.BEGIN_E;
			for (int i = 0; i < righe; i++)
				for (int j = 0; j < colonne; j++)
					if (i == 0 || j == 0 || j == colonne - 1 || i == righe - 1)
						mappa[i][j] = SimulationData.matValues.OBSTACLE;
			int i = 2;
			while (i < righe - 1) {
				if (i % 4 == 2)
					for (int j = 1; j < colonne - 2; j++)
						mappa[i][j] = SimulationData.matValues.OBSTACLE;
				else
					for (int j = 2; j < colonne - 1; j++)
						mappa[i][j] = SimulationData.matValues.OBSTACLE;
				i = i + 2;
			}

			if (mappa[righe - 2][1] == 0 && (righe - 1) % 4 != 2)
				mappa[righe - 2][1] = SimulationData.matValues.GOAL;
			else
				mappa[righe - 2][colonne - 2] = SimulationData.matValues.GOAL;
		}

		// Mappa casuale
		// Start con orientamento e posizione casuale
		// Goal con posizione casuale
		// Il goal =E8 sempre raggiungibile perch=E8 controllo che esista un
		// percorso con OptimumList
		else if (tipo.equals("R")) {
			double area = righe * colonne;
			int perc = (int) Math.ceil(area / 100 * ostacoli);
			String ottima = "";
			int count = 0;

			do {
				mappa = new byte[righe][colonne];
				for (int i = 0; i < righe; i++)
					for (int j = 0; j < colonne; j++)
						if (i == 0 || j == 0 || j == colonne - 1 || i == righe - 1)
							mappa[i][j] = SimulationData.matValues.OBSTACLE;
				for (int i = 0; i < perc; i++) {
					int r = (int) (1 + Math.random() * (righe - 1));
					int c = (int) (1 + Math.random() * (colonne - 1));
					mappa[r][c] = SimulationData.matValues.OBSTACLE;
				}

				int r1 = (int) (1 + Math.random() * (righe - 2));
				int c1 = (int) (1 + Math.random() * (colonne - 2));
				mappa[r1][c1] = (byte) (2 + (Math.random() * 4));
				int r2 = (int) (1 + Math.random() * (righe - 2));
				int c2 = (int) (1 + Math.random() * (colonne - 2));
				while (r1 == r2 && c1 == c2) {
					r2 = (int) (1 + Math.random() * (righe - 2));
					c2 = (int) (1 + Math.random() * (colonne - 2));
				}
				mappa[r2][c2] = SimulationData.matValues.GOAL;

				try {
					// Salvo la mappa per cercare se esiste un cammino dallo
					// start al goal
					PrintStream out = new PrintStream("mappa.txt");
					String line = "";
					out.println(righe);
					out.println(colonne);

					for (int k = 0; k < righe; k++) {
						line = "";
						for (int j = 0; j < colonne; j++) {
							line += mappa[k][j] + " ";
						}
						out.println(line.trim());
					}
					out.close();

				} catch (IOException e) {
					e.printStackTrace();
				}
				/*
				 * if (count == 10000) { win = new WinError(TXT[11]);
				 * win.setVisible(true); return; }else{
				 */
		
				ottima = OptimumList.calcolaOttimo("mappa.txt");
			
				// }
				count++;

			} while (ottima.length() == 0);
		}

		// Salvo la mappa
		try {
			PrintStream out = new PrintStream("mappa.txt");
			String line = "";
			out.println(righe);
			out.println(colonne);

			for (int k = 0; k < righe; k++) {
				line = "";
				for (int j = 0; j < colonne; j++) {
					line += mappa[k][j] + " ";

				}
				out.println(line.trim());
			}
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * aggiorna lo stato dei componenti visuali al caricamento della matrice 
	 * dell'ambiente da file
	 * @param filename file da cui caricare l'ambiente
	 */
	public void updateCompOnMatrixLoad(String filename) {
		try {
			newSimul.loadMatrix(filename);
			pnlEnvironment.paintComponent(pnlEnvironment.getGraphics());
			ngenimax = ((newSimul.envMat.length - 1) * (newSimul.envMat[0].length - 1)) / 2;
			txtNGenivalue.setText("" + ngenimax);
//			int nindmin;
//			if (2 / 3 * perimeter % 2 == 1)
//				nindmin = 2 / 3 * perimeter + 1;
//			else
//				nindmin = 2 / 3 * perimeter;
//			if ((int) (2 / 3 * perimeter) == 0)
//				nindmin = 4;
//			txtNIndvalue.setText("" + nindmin);
			pnlEnvironment.drawMatrix(pnlEnvironment.getGraphics(), newSimul.envMat);
			initStatus = InitStatus.DEF_OBSTACLES;
			if(!pmap){
				btnSave.setEnabled(true);
				savedGoal = true;
				savedStart = true;
			}
			pmap=false;
			status.setText(TXT[43]);
			txtNGenivalue.setEditable(true);
			txtNIndvalue.setEditable(true);
			btnCancel.setEnabled(true);
			btnObstacle.setEnabled(true);
			btnStart.setEnabled(true);
			btnGoal.setEnabled(true);
			
		} catch (IOException e1) {
			win = new WinError(TXT[15]);
			win.setVisible(true);
		}
	}
}
