
import communication.handler.internal.InternalHandler;
import communication.handler.internal.BaseData;
import communication.handler.internal.BaseRegister;
import communication.handler.internal.InternalModule;


/*
Metodi: left() ruota in senso orario con centro a met dell'asse tra le due ruote
           right() ruota in senso antiorario con centro a met dell'asse tra le due ruote
           forward() avanza lentamente
	 fforward() avanza velocemente
	  backward() avanza lentamente
	 bbackrward() avanza velocemente
*/
public class MovControl {

	private InternalHandler internal;

	public MovControl(InternalHandler internal) {
		this.internal = internal;
	} // LedControl
/**
* Metodo che fa ruotare in senso antorario il robot azionando le ruote nelle due direzioni opposte
* @return false in caso di errore
*/
	public boolean left() {
		int buf[] = new int[1];

			buf[0] = 0x12;
		
		try {
			return internal.writeRegister(InternalModule.BASE, BaseRegister.ROTATE_BWD_CCW, buf);
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	} // left
/**
* Metodo che fa ruotare in senso orario il robot azionando le ruote nelle due direzioni opposte
* @return false in caso di errore
*/
	public boolean right() {
		int buf[] = new int[1];
			buf[0] = 0x12;
		try {
			return internal.writeRegister(InternalModule.BASE, BaseRegister.ROTATE_FWD_CW, buf);
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	} // right
/**
* Metodo che fa avanzare velocemente il robot
* @return false in caso di errore
*/	
	public boolean fforward() {
		int buf[] = new int[1];
			buf[0] = 2;
			try {
				return internal.writeRegister(InternalModule.BASE, BaseRegister.FORWARD, buf);
			} catch (Exception e) {
				e.printStackTrace();
				return false;
			}
	} // fforward
/**
* Metodo che fa avanzare il robot
* @return false in caso di errore
*/	
	public boolean forward() {
		int buf[] = new int[1];
			buf[0] = 1;
			try {
				return internal.writeRegister(InternalModule.BASE, BaseRegister.FORWARD, buf);
			} catch (Exception e) {
				e.printStackTrace();
				return false;
			}
		
		
	} // forward
/**
* Metodo che fa indietreggiare velocemente il robot
* @return false in caso di errore
*/	
	public boolean bbackward() {
		int buf[] = new int[1];
			buf[0] = 2;
			try {
				return internal.writeRegister(InternalModule.BASE, BaseRegister.BACKWARD, buf);
			} catch (Exception e) {
				e.printStackTrace();
				return false;
			}
	} // bbackward
/**
* Metodo che fa indietreggiare il robot
* @return false in caso di errore
*/	
	public boolean backward() {
	int buf[] = new int[1];
			buf[0] = 1;
			try {
				return internal.writeRegister(InternalModule.BASE, BaseRegister.BACKWARD, buf);
			} catch (Exception e) {
				e.printStackTrace();
				return false;
			}
	} // backward
/**
* Metodo che fa fermare il robot
* @return false in caso di errore
*/		
	public boolean stop() {
		int buf[] = new int[1];
		buf[0] = 0;
		try {
			return internal.writeRegister(InternalModule.BASE, BaseRegister.FORWARD, buf);
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	} // backward


} // class LedControl

