import java.io.*;

public class Move {
	/**
	 * Esegue tutte le mosse (permesse) codificate dal cromosoma e ritorna il
	 * valore di fitness
	 * 
	 * @param cromosoma
	 * @return fitness
	 */
	public static String solution;
	public static double a;
	public static double b;

	public static double ff1 = 0;
	public static double ff2 = 0;
	public static double ff3 = 0;
	public static double ff; // Fitness Function
	public static double startDistance; // Distanza in linea d'aria dalla
										// posizione attuale allo start
	public static double startDistanceX;
	public static double startDistanceY;
	public static double goalDistance; // Distanza in linea d'aria dalla
										// posizione attuale al goal
	public static double goalDistanceX;
	public static double goalDistanceY;
	public static double minDistance; // Distanza in linea d'aria tra start e
										// goal
	public static double minDistanceX;
	public static double minDistanceY;
	public static int ngenestotal; // #Passi totali
	public static int ngenesbeforecollide; // # Passi percorsi prima di
											// collisione
	public static int ngenesbeforegoal; // # Passi percorsi prima del goal
	public static int collisionx;
	public static int collisiony;
	public static int collisionyPaint;
	public static int collisionxPaint;

	public static double steps(Chromosome cromosome, int ngench, int ngenrun, int test) throws IOException {
		// Carica matrice
		ngenesbeforecollide = GAMP.newSimul.getNGenes();
		// Indici posizione iniziale
		int riga = GAMP.newSimul.getRobotStartPos().y;
		int colonna = GAMP.newSimul.getRobotStartPos().x;
		
		/*
		 * Indica in quale direzione guarda il robot 
		 * 0 = nord 1 = est 2 = sud 3= ovest
		 * conversione da valore della cella di inizio a valore della 
		 * direzione nel path mappata nel range di valori [0, 4] che e' 
		 * quello dei valori accettati dal metodo drawArrow
		 */
		int currDirection = GAMP.newSimul.envMat[riga][colonna] - 2; 

		String genes = cromosome.getChromosome();

		if (GAMP.systemout)
			System.out.println("CROMOSOMA: " + genes);
		int pos = 0;
		boolean ostacolo = false;
		boolean goal = false;
		int oldRiga = riga;
		int oldColonna = colonna;
		// scorro il cromosoma: ogni gene corrisponde a una mossa
		int oldCurrent = currDirection;
		while (pos < genes.length() && ostacolo == false && goal == false) {
			boolean death = false;
			// Se giro in senso orario aggiungo 1 a orientation
			if (genes.charAt(pos) == 'D')
				currDirection = (currDirection + 1) % 4;
			// Se giro in senso antiorario aggiungo 3 che equivale a togliere 1
			// lavorando mod 4
			else if (genes.charAt(pos) == 'S')
				currDirection = (currDirection + 3) % 4;
			// Se trovo A la currentDirection non varia e prosegue in quella
			// direzione
			// Spostamento sulla matrice
			if (currDirection == 0)
				riga = riga - 1;
			else if (currDirection == 1)
				colonna = colonna + 1;
			else if (currDirection == 2)
				riga = riga + 1;
			else if (currDirection == 3)
				colonna = colonna - 1;

			// Scontro contro perimetro
			if (riga == -1 || riga == GAMP.newSimul.envMat.length || colonna == -1 || colonna == GAMP.newSimul.envMat[0].length) {
				ostacolo = true;
				if (ngenesbeforecollide > pos) {
					ngenesbeforecollide = pos + 1;
					collisionx = colonna;
					collisiony = riga;
					collisionxPaint = colonna;
					collisionyPaint = riga;
				}
			}
			// Scontro contro ostacolo interno
			else if (GAMP.newSimul.envMat[riga][colonna] == SimulationData.matValues.OBSTACLE) {
				ostacolo = true;
				if (ngenesbeforecollide > pos) {
					ngenesbeforecollide = pos + 1;
					collisiony = oldRiga;
					collisionx = oldColonna;
					collisionyPaint = riga;
					collisionxPaint = colonna;
				}
				if (GAMP.social) {
					GAMP.newSimul.envMat[riga][colonna] = SimulationData.matValues.DEATH;
					if (GAMP.systemout)
						System.out.println("DEATH at position " + pos + " of " + genes + " in " + riga + ";" + colonna + " Communication->");
				}

			}
			// Arrivo al goal
			else if (GAMP.newSimul.envMat[riga][colonna] == SimulationData.matValues.GOAL) {
				ngenesbeforegoal = pos + 1;
				goal = true;
			}
			// Scontro contro ostacolo mappato da antenati
			else if (GAMP.newSimul.envMat[riga][colonna] == SimulationData.matValues.DEATH) {
				// Torno indietro di una posizione
				// Modifico il gene
				int x = (int) (Math.random() * 3);
				String g = "A";
				if (x == 0)
					g = "D";
				if (x == 1)
					g = "S";
				if (x == 2)
					g = "A";
				if (GAMP.systemout)
					System.out.println("->Communication at position " + pos + "= '" + genes.charAt(pos) + 
							"' of " + genes + "in riga:" + riga + "; colonna:" + colonna);
				// Mutazione
				if (pos == 0)
					genes = g + genes.substring(1, genes.length());
				else if (pos == genes.length() - 1)
					genes = genes.substring(0, genes.length() - 1) + g;
				else
					genes = genes.substring(0, pos) + g + genes.substring(pos + 1, genes.length());
				if (GAMP.systemout)
					System.out.println("->" + genes);
				// Sostituisco il cromosoma
				cromosome.setChromosome(genes);
				GAMP.newSimul.runningGeneration[ngench] = new Chromosome(genes);

				death = true;
			}

			if (death) {
				riga = oldRiga;
				colonna = oldColonna;
				currDirection = oldCurrent;
			} else {
				pos++;
				oldColonna = colonna;
				oldRiga = riga;
				if (GAMP.social)
					oldCurrent = currDirection;
			}
		}


		if (ngenesbeforecollide < GAMP.newSimul.getNGenes()) {
			startDistance = GAMP.newSimul.getDistance(collisionx, collisiony, GAMP.newSimul.getRobotStartPos());
			startDistanceX = GAMP.newSimul.getDistance(collisionx, 0, GAMP.newSimul.getRobotStartPos().x, 0);
			startDistanceY = GAMP.newSimul.getDistance(0, collisiony, 0, GAMP.newSimul.getRobotStartPos().y);
			goalDistance = GAMP.newSimul.getDistance(collisionx, collisiony, GAMP.newSimul.getRobotEndPos());
			goalDistanceX = GAMP.newSimul.getDistance(collisionx, 0, GAMP.newSimul.getRobotEndPos().x, 0);
			goalDistanceY = GAMP.newSimul.getDistance(0, collisiony, 0, GAMP.newSimul.getRobotEndPos().y);
		} else {
			startDistance = GAMP.newSimul.getDistance(colonna, riga, GAMP.newSimul.getRobotStartPos());
			startDistanceX = GAMP.newSimul.getDistance(colonna, 0, GAMP.newSimul.getRobotStartPos().x, 0);
			startDistanceY = GAMP.newSimul.getDistance(0, riga, 0, GAMP.newSimul.getRobotStartPos().y);
			goalDistance = GAMP.newSimul.getDistance(colonna, riga, GAMP.newSimul.getRobotEndPos());
			goalDistanceX = GAMP.newSimul.getDistance(colonna, 0, GAMP.newSimul.getRobotEndPos().x, 0);
			goalDistanceY = GAMP.newSimul.getDistance(0, riga, 0, GAMP.newSimul.getRobotEndPos().y);
		}
		minDistance = GAMP.newSimul.getDistance(GAMP.newSimul.getRobotStartPos(), GAMP.newSimul.getRobotEndPos());
		minDistanceX = GAMP.newSimul.getDistance(GAMP.newSimul.getRobotStartPos().x, 0, GAMP.newSimul.getRobotEndPos().x, 0);
		minDistanceY = GAMP.newSimul.getDistance(GAMP.newSimul.getRobotStartPos().x, 0, GAMP.newSimul.getRobotEndPos().x, 0);
		ngenestotal = GAMP.newSimul.getNGenes();
		if (GAMP.systemout&&ngenesbeforegoal!=0)
			System.out.println("Passi prima di goal: " + ngenesbeforegoal);
		if (GAMP.systemout){
			System.out.println("Numero mosse effettuate: " + pos);
			System.out.println("Distanza dal goal: " + goalDistance);
			System.out.println("Distanza dallo start: " + startDistance );
			System.out.println("Distanza minima in linea d'aria: " + minDistance+ "\n");
		}

		
//		if (GAMP.systemout)
//			System.out.println("Distanza minima in linea d'aria: " + minDistance + " (" + minDistanceX + "," + minDistanceY + ") \n");
//		if (GAMP.systemout)
//			System.out.println("Distanza minima da start: " + startDistance + " (" + startDistanceX + "," + startDistanceY + ") \n");
//		if (GAMP.systemout)
//			System.out.println("Distanza minima da goal: " + goalDistance + " (" + goalDistanceX + "," + goalDistanceY + ") \n");

		if(GAMP.gps){
			if(goalDistance!=0)
				if(goalDistanceX>goalDistanceY){
					goalDistance=2*goalDistanceX;
					
				}
				else{
					goalDistance=2*goalDistanceY;
					
				}
			if(startDistanceX>startDistanceY){
				if(2*startDistanceX>startDistance){
					startDistance=2*startDistanceX;
				}
			}
			else{
				if(2*startDistanceY>startDistance){
					startDistance=2*startDistanceY;
				}
			}
			if(minDistanceX>minDistanceY)minDistance=minDistanceX;
			else minDistance=minDistanceY;

			//Elastica
			ff1 = goalDistance/ (ngenesbeforecollide); 
			double ff1max=(minDistance+ngenestotal);
			double ff1norm=ff1/ff1max;
			
		
			//Rigida
			ff2=(goalDistance+ngenesbeforecollide)/(minDistance+startDistance);
			double ff2max=(minDistance+2*ngenestotal)/minDistance;
			double ff2min=1/minDistance;
			double ff2norm=ff2/ff2max;
			ff=a*ff2norm+b*ff1norm;
		
		}else{

		if (ostacolo == true)
			if (GAMP.systemout)
				System.out.println("Collisione dopo " + ngenesbeforecollide + " mosse in X:" + collisionxPaint + " e Y:" + collisionyPaint);
			else if (GAMP.systemout)
				System.out.println("Nessuna collisione");

		//Elastica
		ff1 = goalDistance/ (startDistance + ngenesbeforecollide); 
		double ff1max=(minDistance+ngenestotal)/ngenestotal;
		double ff1norm=ff1/ff1max;
		
	
		//Rigida
		ff2=(goalDistance+ngenesbeforecollide)/(minDistance+startDistance);
		double ff2max=(minDistance+2*ngenestotal)/minDistance;
		double ff2min=1/minDistance;
		double ff2norm=ff2/ff2max;
		ff=a*ff2norm+b*ff1norm;
		}
		try {
			// Create file
			FileWriter fstream = new FileWriter("Log"+test+"-map_"+GAMP.matrixarg+"_ngeni"+ngenestotal+"_nindiv"+SimulationData.nIndiv+"_sel-"+GAMP.seln+"_crossn-"+GAMP.crossn+"_muta-"+GAMP.mutan+"_ff-"+GAMP.ffn+".dat", true);
			BufferedWriter out = new BufferedWriter(fstream);
			out.write(ngenrun+"\t"+ngench+"\t" + minDistance+"\t" + goalDistance + "\t" + startDistance + "\t"+ngenesbeforecollide+"\t"+ngenesbeforegoal+"\t" + ff + "\n");
			// Close the output stream
			out.close();
		} catch (Exception e) {// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
		// f-a/b-a
		if (GAMP.systemout && GAMP.ffType == 0)
			System.out.println("*******************Fitness Function*******************\n" +
					" FF Simple: \n" 
					+ goalDistance +"* (|"+goalDistance + "-" + startDistance + "+"+ minDistance + "|+1)/"
					+ "(" + ngenestotal + "+"+minDistance+"+1) = " + ff3
					+"\n******************************************************\n");
		if (GAMP.systemout && GAMP.ffType == 1)
			System.out.println("*******************Fitness Function*******************\n" +
					"a=" + a + ";b=" + b + " FF Complex: \n(((" 
					+ goalDistance + "+" + startDistance + ")/" + minDistance + "-1)*" + minDistance
					+ "/" + ngenestotal + " =" + ff1 + "\n+\n" +
					goalDistance + "/("+ngenesbeforecollide+" * ("+minDistance+" + "+ngenestotal+")) ="+ff2
					+"\n=\n"+ff+"\n******************************************************\n");
			if(GAMP.systemout)System.out.println("------>a=" + a + ";b=" + b + " FF: (a*" + ff1 + "+b*" + ff2 + ")=" + ff);

		if (goalDistance == 0)
			return 10000;
		else if (ff == 0)
			return 0.00001;
		else
			return ff;
	}

	/**
	 * Calcola la distanza col teorema di Pitagora
	 * 
	 * @param rAttuale
	 * @param cAttuale
	 * @param rGoal
	 * @param cGoal
	 * @return
	 */
	public static double distanza(int rAttuale, int cAttuale, int rGoal, int cGoal) {
		return Math.sqrt(Math.pow((rAttuale - rGoal), 2) + Math.pow((cAttuale - cGoal), 2));
	}
}
