package communication.handler.internal;

/**
 * Definitions of Brain register values
 * 
 * @author Paolo
 */
public interface BrainData
{
	// basic behaviors
	public final static int ENABLE_VISION = 0x01;
	
	// user programs
	public final static int BUILD_PROGRAM = 0x02;
	public final static int START_PROGRAM = 0x01;
	public final static int STOP_PROGRAM = 0x00;

	// commands
	public final static int TAKE_PICTURE = 0x01;
	public final static int GOTO_SLEEP = 0xFF;

	// remote control (bit mask)
	public final static int REMOTE_STOP = 0;
	public final static int REMOTE_LEARN = 0x20;
	public final static int REMOTE_SEND = 0x40;
	public final static int REMOTE_REPEAT = 0x60;
	
	// cmos image sensor
	public final static int AUTO_EXPOSURE = 0x01;
	public final static int AUTO_WHITE_BALANCE = 0x02;
}
