package communication.handler.internal;

/**
 * Definitions of Hand register values
 * 
 * @author Paolo
 */
public interface HandData
{
	// hand command
	public final static int STOP = 0;
	public final static int OPEN = 1; // also status
	public final static int CLOSE = 2; // also status
	public final static int OPEN_CUR = 3;
	public final static int CLOSE_CUR = 4;

	// hand status
	public final static int UNKNOWN = 0;
	public final static int MOVING = 0x20;

	// force levels
	public final static int FORCE_MAX = 10;
	public final static int FORCE_MIN = 1;
	public final static int FORCE_DEFAULT = 0;
	
	// current levels
	public final static int CURRENT_MAX = 80; // 800mA
}
