package communication.handler.internal;

/**
 * Definitions of Head register values
 * 
 * @author Paolo
 */
public interface HeadData
{
	public final static int PAN_MAX = 12;
	public final static int TILT_MAX = 4;

	public final static int LEFT_EAR = 0x01;
	public final static int RIGHT_EAR = 0x10;
	public final static int LEFT_EYE_YELLOW = 0x02;
	public final static int RIGHT_EYE_YELLOW = 0x20;
	public final static int LEFT_EYE_RED = 0x04;
	public final static int RIGHT_EYE_RED = 0x40;
	public final static int LEFT_EYE_GREEN = 0x08;
	public final static int RIGHT_EYE_GREEN = 0x80;
	public final static int POWER_STANDBY = 0xFF;
	public final static int POWER_RESET = 0x55;
	public final static int SOUND_FOLLOWER = 0x80;
	public final static int MICROPHONE_INPUT = 0x40;
	public final static int TOUCH_ACTION = 0x01;
	
	public final static int TOUCH_BIT = 0x01;
	public final static int SOUND_MASK = 0x0E;
	public final static int SOUND_REAR = 0x02;
	public final static int SOUND_LEFT = 0x04;
	public final static int SOUND_FRONT_LEFT = 0x06;
	public final static int SOUND_FRONT = 0x08;
	public final static int SOUND_FRONT_RIGHT = 0x0A;
	public final static int SOUND_RIGHT = 0x0C;
	
}