package communication.handler.internal;

/**
 * Defines constants used to identify internal modules.
 * 
 * @author Paolo
 */
public interface InternalModule
{
	/**
	 * Head module (sound follower, touch sensor, head pan and tilt motors)
	 */
	final static int HEAD = 1;

	/**
	 * Base module (obstacle avoidance, proximity sensors, hip and wheels
	 * motors)
	 */
	final static int BASE = 2;

	/**
	 * Voice module (speech recognition and playback, audio message handling)
	 */
	final static int VOICE = 3;

	/**
	 * Motherboard module (battery level sensors, lcd and keyboard handling)
	 */
	final static int MOTHERBOARD = 3;

	/**
	 * Arms module (digital input/outputs, analog inputs, arms motors)
	 */
	final static int ARMS = 4;
	
	/**
	 * Hand module (open/close hand tool)
	 */
	final static int HAND = 5;
	
	/**
	 * Universal Remote Control module (send/receive infrared codes)
	 */
	final static int URC = 6;
	
	/**
	 * Brain module (behaviors, photo, video streaming, user programs)
	 */
	final static int BRAIN = 0;
}
