package communication.protocol;

/**
 * Interface for implementing Bus protocol capability
 * 
 * @author Paolo
 */
public interface BusListener
{
	/**
	 * Receives results and data of a bus transfer request
	 * 
	 * @param data
	 *            Array of buffers filled in with data of read messages, in the
	 *            same order as in the request
	 * 
	 * @see Chunk#BUS_RESULT
	 */
	public void onBusResult(byte[][] data);
}
