package communication.protocol;

/**
 * Defines constants used to identify protocol capabilities. Can be combined
 * with bitwise OR operator.
 * 
 * @author Paolo
 */
public interface Capability
{
	/**
	 * Can access internal modules registers
	 */
	final static int INTERNAL = 0x01;

	/**
	 * Can access generic modules on the bus
	 */
	final static int BUS = 0x02;

	/**
	 * Can handle audio streaming
	 */
	final static int AUDIO = 0x04;

	/**
	 * Can handle video streaming
	 */
	final static int VIDEO = 0x08;

	/**
	 * Can handle messages (application specific)
	 */
	final static int MESSAGE = 0x10;

	/**
	 * Can handle debug events
	 */
	final static int DEBUG = 0x20;

	/**
	 * Can handle file transfers
	 */
	final static int TRANSFER = 0x40;

	/**
	 * Can handle generic protocol extensions
	 */
	final static int EXTENSION = 0x80;
}
