/**
 * 
 */
package communication.transport;

/**
 * Interface for listening to low-level connection events.
 * 
 * @author Paolo
 */
public interface ConnectionListener
{
	/**
	 * Event handler called as soon as the provider has established a
	 * connection. The input and output streams are valid from now on.
	 */
	public void onConnection();

	/**
	 * Event handler called when the provider is about to disconnect. The input
	 * and output streams cease to be valid afterwards.
	 */
	public void onDisconnection();
}
